!Last change 05.04.2006
Module definitions
real*8 ran1,mini
integer time1,time2,time3,time0,iseed,filen,length,nu,ic
real, allocatable:: rad(:,:),out(:,:),sample(:,:),def(:),in(:)
real total,item,item1,item2,total2,min,max,sadslope,sadslope1,tot
integer zahl,ii,fwide,cases,outwide,variables,samps,zahl2,iter,num1,filec,iter1,species,iter2,itermax,species1,cases1,casesnew
character*10 time,types,sampling,sampmod,sad,t,mult,fill
character*650 text
character*50 tt(300),abund,spnumb,text1
end module definitions

program Matrix
use definitions
integer*4 i,j,jj
integer, allocatable:: row(:),col(:)
real fac
real*8 norm
fwide=5
outwide=200
cases=1000
length=650
iter=1
iter1=1
iter2=0
iter3=0
itermax=100
num1=1
sampmod='r'
text=' '
sad=' '
abund='yes'
spnumb=' '
sadslope=0
sadslope1=0
mult='yes'
fill='no'
tot=0
call date_and_time(time=time)
read(time(1:2),'(i2)')time1
read(time(3:4),'(i2)')time2
read(time(5:6),'(i2)')time3
time0=time1*3600+time2*60+time3
call random_seed
call random_number(ran1)
iseed=nint(ran1*(10**9))
call copy
!open(8,file='Mattest.txt',status='replace')
1 write(*,*)'Name of abundance file with extension. First line has to be a comment line.'
write(*,*)'If abundances have to be computed leave blank.'
read(*,'(a)',advance='yes',eor=113)abund
113 if(abund.ne.' ')then
open(7,file=abund,status='old',err=1)
read(7,'(a50)')text
i=0
do while (i.ge.0)
read(7,'(a)',err=14,end=14)text
if(text.ne.' ')i=i+1
enddo
14 cases=i
if(cases.lt.2)goto 1000
rewind (7)
read(7,'(a50)')t
else
114 open(7,file='Model.txt',status='replace')
write(*,*)'Type of species pool species abundance distribution:'
write(*,*)'Lognormal (n), power function (p), or logseries (l)'
write(*,*)'If fully nested matrix type f,if checkerboard matrix type c' 
write(*,*)'If equiprobable random matrix type e'
read(*,'(a1)')sad
if(sad.ne.'l'.and.sad.ne.'n'.and.sad.ne.'p'.and.sad.ne.'f'.and.sad.ne.'c'.and.sad.ne.'e')goto 114
if(sad.eq.'n')then
sadslope=2.5
write(*,*)'Shape parameter of the lognormal distribution'
write(*,*)'Default = 0.2 (canonical lognormal)'
write(*,*)'If random assigment between 0.10 and 0.5 type -1.0'
read(*,'(f8.5)',advance='yes',eor=111)sadslope
if((sadslope.lt.0.or.sadslope.ge.1.0).and.sadslope.ne.-1.0)goto 114
111 if(sadslope.eq.0)then
sadslope=0.2
sadslope=1.0/(2.0*sadslope)
elseif(sadslope.eq.-1.0)then
sadslope1=sadslope
else
sadslope=1.0/(2.0*sadslope)
endif
elseif(sad.eq.'l')then
118 write(*,*)'Shape parameter of the logseries distribution'
write(*,*)'If random assigment between 0.01 and 0.2 type -1.0'
read(*,*)sadslope
if((sadslope.le.0.or.sadslope.ge.1).and.sadslope.ne.-1.0)goto 118
if(sadslope.eq.-1.0)sadslope1=-1.0
elseif(sad.eq.'p')then
115 write(*,*)'Shape parameter of the power function distribution'
write(*,*)'If random assigment between 0.5 and 5.0 type -1.0'
read(*,*)sadslope
if((sadslope.lt.0.or.sadslope.ge.5).and.sadslope.ne.-1.0)goto 115
if(sadslope.eq.-1.0)sadslope1=-1.0
endif
endif
117 write(*,*)'Name of species numbers per site file. First line has to be a comment line.'
write(*,*)'If species numbers have to be computed leave blank.'
read(*,'(a)',advance='yes',eor=112)spnumb
112 if(spnumb.ne.' ')then
open(8,file=spnumb,status='old',err=117)
read(8,'(a50)')text
iter1=10000
else
13 write(*,'(a,i3)')'Number of sites, 3<sites<',outwide
read(*,'(i4)',err=13)num1
if(num1.lt.3.or.num1.gt.outwide-1) goto 13
if(abund.eq.' ')then
123 write(*,*)'Number of species of the species pool (>2)'
read(*,*) cases
if(cases.lt.3)goto 123
endif
endif
open(3,file='temp.txt',status='replace')
open(4,file='Output.txt',status='replace')
if(mult.eq.'yes')then
open(9,file='fab.txt',status='replace')
write(9,'(a)')'Abundance files'
open(10,file='fpa.txt',status='replace')
write(10,'(a)')'Presence absence files'
endif
if(spnumb.ne.' ')write(4,'(a4,10x,a4,10x,a5,1x,a5,1x,a5,1x,a8,1x,a6,1x,a6,1x,a15)')'File','File','Shape',' Spec','Sites','SSize','Fill','Ma/Mi','Species numbers'
if(spnumb.eq.' ')write(4,'(a4,10x,a5,1x,a5,1x,a5,1x,a8,1x,a6,1x,a6,1x,a15)')'File','Shape',' Spec','Sites','SSize','Fill','Ma/Mi','Species numbers'
col=1
15 if(sad.ne.'f'.and.sad.ne.'c'.and.sad.ne.'e')then
write(*,*)'Sampling individuals (i) or species (s)'
read(*,'(a)',err=15)types
if(types.ne.'i'.and.types.ne.'s')goto 15
!types='i'
sampling='yes'
!16 write(*,*)'Sampling with replacement (yes) or without replacement (no)'
!read(*,'(a)',err=16)sampling
!if(sampling.ne.'yes'.and.sampling.ne.'no')goto 16
endif
write(*,*)'Start number of file counting'
read(*,*)filec
filec=filec-1
iter3=filec
17 write(*,*)'Number of output files, <1000'
if(mult.ne.'yes')then
read(*,'(i4)',err=17)iter
else
read(*,'(i4)',err=17)itermax
iter=1
endif
if(iter.lt.1.or.iter.ge.1000)goto 17
if(spnumb.eq.' ')then
18 if(sad.ne.'f'.and.sad.ne.'c'.and.sad.ne.'e')then
write(*,*)'Site diversities: equal (e), random (r), or unequal (u)'
read(*,'(a)') sampmod
if(sampmod.ne.'e'.and.sampmod.ne.'u'.and.sampmod.ne.'r')goto 18
endif
endif
allocate(def(outwide))
species1=cases
sites1=num1
400 if(mult.eq.'yes')then
cases=int(ran(iseed)*(species1-3.0))+3
num1 =int(ran(iseed)*(sites1-3.0))+3
iter2=iter2+1
endif
do 250 ii=1,iter1
iter3=iter3+1
def=0
if(spnumb.ne.' ')then
filen=8
call reading
if(nu.eq.0)goto 1001
read(tt(1),*)text1
read(tt(2),*)species
if(species.lt.cases)cases=species
do 101 j=3,nu
read(tt(j),*,end=103,err=103)def(j-2)
!def(j-2)=def(j-2)/real(cases)
101 continue
num1=nu-2
endif
allocate(in(cases),rad(cases,fwide),out(cases,outwide),row(cases),col(outwide))
if(sad.eq.'f')then
call nest (out,cases,num1,outwide,iseed)
goto 103
endif
if(sad.eq.'c')then
call checker (out,cases,num1,outwide,iseed)
goto 103
endif
if(sad.eq.'e')then
call equi (out,cases,num1,outwide,iseed)
goto 103
endif
if(abund.ne.' ')then
do 100 i=1,cases
read(7,*,end=103,err=103)in(i)
100 continue
rewind(7)
read(7,'(a)')t
else
if(sad.eq.'n')then
if(sadslope1.eq.-1.0)then
if(cases.gt.3)sadslope=ran(iseed)*0.40+0.10
if(cases.gt.50)sadslope=ran(iseed)*0.35+0.15
if(cases.gt.100)sadslope=ran(iseed)*0.30+0.20
if(cases.gt.150)sadslope=ran(iseed)*0.25+0.25
sadslope=1.0/(2.0*sadslope)
endif
call lnormal(in,cases,iseed,sadslope,tot)
elseif(sad.eq.'l')then
if(sadslope1.eq.-1.0)sadslope=ran(iseed)*0.19+0.01
call lseries(in,cases,iseed,sadslope,tot)
elseif(sad.eq.'p')then
if(sadslope1.eq.-1.0)sadslope=ran(iseed)*4.5+0.5
call zm(in,cases,iseed,sadslope,tot)
endif
endif
103 do 500 iii=1,iter
if(mult.eq.'no')write(*,'(a10,i4,1x,a9,i5,1x,a7,i5)')'Iteration: ',iii,'Species: ',cases,'Sites: ',num1
if(mult.eq.'yes')write(*,'(a10,i4,1x,a9,i5,1x,a7,i5)')'Iteration: ',iter3,'Species: ',cases,'Sites: ',num1
if(sad.eq.'f'.or.sad.eq.'c'.or.sad.eq.'e')goto 200
if(spnumb.eq.' ')call samp(def,cases,outwide,num1,iseed,sampmod)
total=0
zahl=0
rad=0
item=0
out=0
min=10**9
max=-1.0
do 201 i=1,cases
!if(in(i).gt.0)then
rad(i,5)=i
rad(i,1)=in(i)
rad(i,2)=in(i)
zahl=zahl+1
if(rad(i,2).gt.max)max=rad(i,2)
if(rad(i,2).lt.min)min=rad(i,2)
!endif
201 continue
do 203 i=1,cases
if(max.le.1.and.min.lt.1)then
rad(i,1)=rad(i,1)/min
endif
total=total+rad(i,1)
203 continue
if(total.ge.100000000.0)total=100000000.0
if(spnumb.eq.' ')then
if(types.eq.'i')def=def*total
if(types.eq.'s')def=def*cases
endif
if(mult.eq.'yes')write(*,'(a,f15.0,1x,a,f6.2)')'Total sample space: ',total,'SAD slope: ',1.0/(2.0*sadslope)
do 300 k1=1,num1
item=def(k1)
do 301 i=1,cases
rad(i,2)=rad(i,1)
rad(i,3)=0
rad(i,4)=1
301 continue
ic=0
zahl2=cases
total2=total
item2=0.1
item1=item
!if(types.eq.'i')item1=item*total
!if(types.eq.'i')item1=item*cases
!if(types.eq.'s')item1=item*cases
if(item1.gt.0)then
do while (item2.lt.item1)
ic=ic+1
if(ic.gt.total)goto 401
call prob (jj)
if(types.eq.'i')then
if(rad(jj,3).lt.rad(jj,2).and.jj.gt.0.and.jj.le.cases)then
rad(jj,3)=rad(jj,3)+1
if(sampling.eq.'no')then
if(rad(jj,2).gt.0)rad(jj,2)=rad(jj,2)-1
if(rad(jj,2).gt.0)total2=total2-1
endif
item2=item2+1
endif
elseif(types.eq.'s')then
if(rad(jj,3).lt.rad(jj,2).and.jj.gt.0.and.jj.le.cases)then
rad(jj,3)=rad(jj,3)+1
rad(jj,4)=0
if(sampling.eq.'no')then
if(rad(jj,2).gt.0)rad(jj,2)=rad(jj,2)-1
if(rad(jj,2).gt.0)total2=total2-1
endif
item2=0
do 5 k=1,cases
5 if(rad(k,4).eq.0)item2=item2+1
endif
endif
enddo
endif
401 do 202 k2=1,cases
out(k2,k1)=rad(k2,3)
202 continue
300 continue
200 a=a
call sortrow(out,row,cases,outwide)
call sortcol(out,col,cases,outwide)
casesnew=cases
do 251 i=1,cases
do 252 j=1,outwide
252 if(out(i,j).ne.0)goto 251
casesnew=i-1
goto 255
251 continue
255 if(casesnew.lt.3)goto 501
call nestocc(out,cases,outwide,filec,num1,text1,spnumb,types,mult,sadslope,casesnew)
500 continue
501 deallocate (in,rad,out,row,col)
if(mult.eq.'yes')then
if(iter2.gt.itermax)goto 1001
goto 400
endif
250 continue
1001 call date_and_time(time=time)
read(time(1:2),'(i2)')time1
read(time(3:4),'(i2)')time2
read(time(5:6),'(i2)')time3
time1=time1*3600+time2*60+time3-time0
time2=int1(time1/3600.0)
time3=int1(time1/60.0)-time2*60
time1=time1-time3*60-time2*3600
write(*,'(a,i3,a,i3,a,i3,a)')'Runtime of program: ',&
time2,'hh',time3,'min',time1,'sec'
pause
stop
1000 write(*,*)'Too few species'
pause
stop
end

subroutine copy
use definitions
write(*,*)'*******************************************************'
write(*,*)'*                                                     *' 
write(*,*)'* Program Matrix: Version 1; 06.04.2006               *' 
write(*,*)'*                                                     *' 
write(*,*)'* Copyright Dr. Werner Ulrich                         *'
write(*,*)'*                                                     *'
write(*,*)'* The author does not take responsibility for correct *'
write(*,*)'* program run or any damages caused by the program.   *'
write(*,*)'*                                                     *'
write(*,*)'*******************************************************'
write(*,*)
return 
end

subroutine reading 
use definitions
integer i,j
text=' '
tt=' '
read(filen,'(a<length>)',err=4,end=4) text
!read(filen,*,err=2,end=4) text
nu=1
i=1
do while (i.le.length-1)
if(text(i:i).ne.' ')then
do 1 j=i,length
if(text(j:j).eq.' ') then
if(nu.gt.300) goto 2 
tt(nu)=text(i:j-1)
i=j
nu=nu+1
if(i.gt.length-2.and.nu.lt.2)goto 4
goto 3
endif
1 continue
endif
i=i+1
if(i.gt.length-2.and.nu.lt.2)goto 4
3 enddo
if(nu.lt.2)goto 2
nu=nu-1
return
4 write(*,*) 'End of input file reached'
close(filen)
nu=0
return
2 write(*,*)'Error while reading file'
write(*,*)text
1000 call date_and_time(time=time)
read(time(1:2),'(i2)')time1
read(time(3:4),'(i2)')time2
read(time(5:6),'(i2)')time3
time1=time1*3600+time2*60+time3-time0
time2=int1(time1/3600)
time3=int1(time1/60)-time2*60
time1=time1-time3*60-time2*3600
write(*,'(a,i3,a,i3,a,i3,a)')'Runtime of program: ',&
time2,'hh',time3,'min',time1,'sec'
pause
stop
end

real*8 function norm(iseed)
real*8 a
a=0
do while(a.lt.0.000000001)
a=ran(iseed)
enddo
norm=sqrt(-2.0*dlog(a))*cos(2.0*3.14159*ran(iseed))
!write(*,*) norm
end function

subroutine sort (field,i,j,k)
real field(i,j),an(j)
do 2 j1=1,i-1
do 1 i1=j1+1,i
do 3 k1=1,j
an(k1)=field(j1,k1)
3 continue
if(field(i1,k).gt.an(k))then
do 5 k1=1,j
field(j1,k1)=field(i1,k1)
field(i1,k1)=an(k1)
5 continue
endif
1 continue
2 continue
return
end


subroutine prob (jj)
use definitions
integer*4 jj
real an,probf(cases)
probf=0
probf(1)=rad(1,2)
do 1 i=2,cases
probf(i)=rad(i,2)+probf(i-1)
1 continue
an=ran(iseed)*probf(cases)
do 2 jj=1,cases
if(an.lt.probf(jj))return
2 continue
jj=0
return
end

subroutine nestocc(mat,species,sites,filec,num,text1,spnumb,types,mult,sadslope,speciesnew)
integer species,sites,filec,num,def1,def2,filen,speciesnew
character*10 types,ne,mult
character*50 text,name,name1,text1,spnumb
real mat(species,sites),counter(sites),counter1(sites)
filec=filec+1
write(3,*)filec
backspace (3)
read(3,*)text
backspace (3)
name='Matab'
name1='Matpa'
ne=' '
name=name(1:5)//text
i1=len_trim(name)
name=name(1:i1)//'.txt'
name1=name1(1:5)//text
i1=len_trim(name1)
name1=name1(1:i1)//'.txt'
open(2,file=name,status='Replace')
filen=2
if(mult.eq.'yes')write(9,'(a15)')name
if(mult.eq.'yes')write(10,'(a15)')name1
counter=0
counter1=0
do 7 i=1,num
counter1(i)=i
7 continue
write(filen,'(a2,3x,<num>(f12.3,1x))')' S',(counter1(j),j=1,num)
call spaces (num,filen)
do 8 i=1,speciesnew
write(filen,'(i4,1x,<num>(f12.1,1x))')i,(mat(i,j),j=1,num)
call spaces (num,filen)
8 continue
close(filen)
i3=0
do 22 i1=1,species
do 21 i2=1,num
if(mat(i1,i2).gt.0)i3=i3+1
21 continue
22 continue
counter=0
def1=0
do 16 j=1,num
do 15 i=1,species
if(mat(i,j).gt.0)then
def1=def1+mat(i,j)
mat(i,j)=1
counter(j)=counter(j)+1
endif
15 continue
16 continue
def2=0
do 23 i=1,species
do 24 j=1,num
if(mat(i,j).gt.0)then
def2=def2+1
goto 23
endif
24 continue
23 continue
a1=0
a2=100000000
do 18 i=1,num
if(counter(i).lt.a2)a2=counter(i)
if(counter(i).gt.a1)a1=counter(i)
18 continue
if(a2.gt.0)then
a1=a1/a2
else
a1=-1
endif
if(types.eq.'s')def1=def2
open(1,file=name1,status='Replace')
filen=1
write(filen,'(a2,2x,<num>(f4.1,1x))')' S',(counter1(j),j=1,num)
call spaces (num,filen)
do 17 i=1,speciesnew
write(filen,'(i4,1x,<num>(f3.1,1x))')i,(mat(i,j),j=1,num)
call spaces (num,filen)
17 continue
close(filen)
if(spnumb.ne.' ')write(4,'(a13,1x,a13,1x,f5.2,1x,i5,1x,i5,1x,i8,1x,f6.4,1x,f6.2,1x,<num>(i4,1x))')text1,name,sadslope,speciesnew,num,def1,real(i3)/(speciesnew*num),a1,(int(counter(i)),i=1,num)
if(spnumb.eq.' ')write(4,'(a13,1x,f5.2,1x,i5,1x,i5,1x,i8,1x,f6.4,1x,f6.2,1x,<num>(i4,1x))')name,sadslope,speciesnew,num,def1,real(i3)/(speciesnew*num),a1,(int(counter(i)),i=1,num)
return
end

subroutine spaces(sa,filen)
integer length,sa,filen
character*650 text
text=' '
length=650
backspace (filen)
read(filen,'(a<length>)') text
backspace(filen)
!write(*,*) length,text(1:60)
do 1 i=1,length
if(text(i:i).eq.' ')then
k=0
do while (text(i+1:i+1).eq.' ')
k=k+1
if(k.gt.length-i) goto 4
do 2 j=i+1,length-1
text(j:j)=text(j+1:j+1)
2 continue
enddo
endif
1 continue
4 do 3 j=1,length-1
text(j:j)=text(j+1:j+1)
3 continue
do 5 j=1,length
if(text(j:j).eq.' '.and.text(j+1:j+1).eq.' ')then
length=j-1
goto 6
endif
5 continue
6 write(filen,'(a<length>)')text(1:length)
!write(*,*) text
return
end

subroutine samp(def,species,sites,num1,iseed,sampmod)
integer sites,species,spec,num1
integer*4 iseed
real def(sites)
real a,a1,a2,a3
character*10 sampmod
def=0
1 spec=max(3,int(ran(iseed)*species)+1)
if(sampmod.eq.'u')then
a3=spec/a3
a1=a3*(exp(ran(iseed)-1)+1)
a2=a3*(1-exp(ran(iseed)-1))
if(a1.lt.a2)then
a=a2
a2=a1
a1=a
endif
if(a2.lt.2) goto 1
a=(a1-a2)/real(num1)
do 2 i=1,num1
def(i)=(a1-a*i)/spec
write(*,*)a,def(i)
2 continue
return
elseif(sampmod.eq.'r')then
do 3 i=1,num1
def(i)=real((int(ran(iseed)*spec)+1.0))/real(spec)
!write(*,*)a,def(i)
3 continue
return
elseif(sampmod.eq.'e')then
a1=ran(iseed)
do 4 i=1,num1
def(i)=a1
4 continue
return
endif
end


subroutine lnormal (field1,spec,iseed,a,tot)
integer spec,iseed,num
real field(spec),a,b,tot,field1(spec)
real*8 norm
write(7,'(a,f5.2,1x,a,i5)')'Model: ',a,'Species: ',spec
write(7,'(a)')'Relative abundances used for sampling'
10 num=10
field1=0
tot=0
do 5 k=1,num
field=0
b=0
do 1 i=1,spec
2 field(i)=a*norm(iseed)
if(field(i).lt.16.and.field(i).gt.-16)then
field(i)=exp(field(i))
b=b+field(i)
else
goto 2
endif
1 continue
call sort(field,spec,1,1)
if(b.gt.0)then
do 3 i=1,spec
field(i)=field(i)/b
field1(i)=field(i)+field1(i)
tot=tot+field(i)
3 continue
else
close(7)
goto 10
endif
5 continue
do 6 i=1, spec
field1(i)=field1(i)/real(num)
write(7,*)field1(i)
6 continue
return
end

subroutine lseries(field,spec,iseed,a,tot)
integer spec,iseed
real field(spec),a,b,tot
real*8 norm
write(7,'(a)')'Relative abundances used for sampling'
b=0
tot=0
field=0
field(1)=1
do 1 i=2,spec
field(i)=(ran(iseed)**a)*field(i-1)
!write(*,*)a,field(i)
b=b+field(i)
if(field(i).lt.0.000000001)goto 2
1 continue
2 call sort(field,spec,1,1)
if(b.gt.0)then
do 3 i=1,spec
field(i)=field(i)/b
tot=tot+1.0/field(i)
write(7,*)field(i)
3 continue
else
field=0
endif
return
end

subroutine zm(field,spec,iseed,a,tot)
integer spec,iseed
real field(spec),a,b,tot
real*8 norm
write(7,'(a)')'Relative abundances used for sampling'
b=0
tot=0
field=0
do 1 i=1,spec
field(i)=ran(iseed)**(a)
!write(*,*)a,field(i)
b=b+field(i)
if(field(i).lt.0.000000001)goto 2
1 continue
2 call sort(field,spec,1,1)
if(b.gt.0)then
do 3 i=1,spec
field(i)=field(i)/b
tot=tot+1.0/field(i)
write(7,*)field(i)
3 continue
else
field=0
endif
return
end

subroutine sortrow(field,row,sp,si)
integer sp,si
integer row(sp),a
real field(sp,si),an(si)
row=0
do 10 i1=1,sp
do 11 j1=1,si
if(field(i1,j1).gt.0)row(i1)=row(i1)+1
11 continue
10 continue
do 2 j1=1,sp-1
do 1 i1=j1+1,sp
if(row(i1).gt.row(j1))then
do 5 k1=1,si
an(k1)=field(j1,k1)
field(j1,k1)=field(i1,k1)
field(i1,k1)=an(k1)
5 continue
a=row(j1)
row(j1)=row(i1)
row(i1)=a
endif
1 continue
2 continue
return
end

subroutine sortcol(field,col,sp,si)
integer sp,si
real field(sp,si),an(sp)
integer col(si),a
col=0
do 10 i1=1,si
do 11 j1=1,sp
if(field(j1,i1).gt.0)col(i1)=col(i1)+1
11 continue
10 continue
do 2 j1=1,si-1
do 1 i1=j1+1,si
if(col(i1).gt.col(j1))then
do 5 k1=1,sp
an(k1)=field(k1,j1)
field(k1,j1)=field(k1,i1)
field(k1,i1)=an(k1)
5 continue
a=col(j1)
col(j1)=col(i1)
col(i1)=a
endif
1 continue
2 continue
return
end

subroutine nest(out,cases,num1,outwide,iseed)
integer cases,num1,outwide,iseed
real out(cases,outwide)
out=0
do 1 i=1,cases
k=int(num1*ran(iseed))+1
do 2 j=1,k
out(i,j)=1.0
2 continue
1 continue
return
end

subroutine checker(out,cases,num1,outwide,iseed)
integer cases,num1,outwide,iseed,k1
real out(cases,outwide)
out=0
k1=2
do 1 i=1,cases
if(k1.eq.1)then 
k1=2
goto 3
else
k1=1
endif
3 if(i.eq.1.or.i.eq.2)then 
k=num1
else
k=int(num1*ran(iseed))+1
endif
if(k.lt.k1)goto 3
do 2 j=k1,k,2
out(i,j)=1.0
!write(*,*)out(i,j)
2 continue
1 continue
return
end

subroutine equi(out,sp,si,outwide,iseed)
integer sp,si,iseed,outwide,total,total1
integer counter(sp),counter1(si)
real out(sp,outwide),fill
out=0.0
counter=0
counter1=0
total=0
total1=0
do while(total.lt.sp.and.total1.lt.si)
2 i=int(ran(iseed)*sp)+1
j=int(ran(iseed)*si)+1
if(out(i,j).eq.1)goto 2
out(i,j)=1.0
if(counter(i).lt.1)then
counter(i)=1
total=total+1
endif
if(counter1(j).lt.1)then
counter1(j)=1
total1=total1+1
endif
enddo
return
end
