!Last change 25.05.2003
Module definitions
real*8 ran1
integer time1,time2,time3,time0,iseed,filen,length,nu
integer species,sites,max,count
real fac,mfill
real,allocatable:: mat(:,:)
character*10 time,fill,mult,t,test,special,zerofill
character*650 text
character*50 tt(300),name,name1,name2
character*20, allocatable:: spname(:),siname(:)
end module definitions

program MatrixChange
use definitions
integer k2,k3
real br,brnew 
real*8 norm
br=0
brnew=0
length=650
mult='no'
max=1
filen=1
test='no'
special='no'
name=' '
zerofill='no'
if(test.eq.'yes')open(8,file='Test.txt',status='replace')
if(special.eq.'yes')then
open(9,file='Special.txt',status='replace')
write(9,'(a15,5(a5,1x))')'Filename','Spec','Sites','UnexA','UnexO','Fill'
endif
call date_and_time(time=time)
read(time(1:2),'(i2)')time1
read(time(3:4),'(i2)')time2
read(time(5:6),'(i2)')time3
time0=time1*3600+time2*60+time3
call random_seed
call random_number(ran1)
iseed=int(ran1*(10**9))
call copy
31 write(*,*)'Type of structure change:'
write(*,*)'Nestedness: Equiprobable (e), fixed rows (r), or fixed rows and columns (f)'
write(*,*)'Co-occurrence: Equiprobable (c), fixed rows (g), or fixed rows and columns (d)' 
read(*,'(a1)')name2
if(name2.ne.'e'.and.name2.ne.'r'.and.name2.ne.'f'.and.name2.ne.'c'.and.name2.ne.'d'.and.name2.ne.'g')goto 31
30 if(name2.ne.'c'.and.name2.ne.'d')write(*,*)'More (n) or less (r) nested matrix to generate?'
if(name2.eq.'c'.or.name2.eq.'d')write(*,*)'More (r) or less (n) checkerboards'
read(*,'(a1)')fill
if(fill.ne.'n'.and.fill.ne.'r')goto 30
write(*,*)'Factor of change'
read(*,*)fac
1 write(*,*)'Name of input file with extension. First line has to be a comment line'
write(*,*)'For multiple run leave blank'
read(*,'(a50)',err=1)name
if(name.ne.' ')then
open(filen,file=name,status='old',err=1)
goto 3
else
2 write(*,*)'Name of file with file names (with extension).' 
write(*,*)'First line has to be a comment line.'
read(*,'(a50)',err=2)name1
open(2,file=name1,status='old',err=2)
read(2,'(a10)',err=2,end=2)t
open(4,file='filelist.txt',status='replace')
write(4,'(a10,f5.3)')'File list: ',fac
mult='m'
max=10000
endif
3 do 1000 iii=1,max
10 if(mult.eq.'m')then
read(2,'(a50)',err=10,end=1001)name
open(filen,file=name,status='old',err=10)
endif
call matread
if(species.lt.2.or.sites.lt.2)goto 3
if(name2.eq.'e')call matchange1(mat,spname,siname,species,sites,fill,fac,test,k2,k3,mfill,br,brnew,count)
if(name2.eq.'r')call matchange2(mat,spname,siname,species,sites,fill,fac,test,k2,k3,mfill,br,brnew,count,zerofill)
if(name2.eq.'f')call matchange3(mat,spname,siname,species,sites,fill,fac,test,k2,k3,mfill,br,brnew,count,zerofill)
if(name2.eq.'c'.or.name2.eq.'g')call matchange4(mat,spname,siname,species,sites,fill,fac,test,k2,k3,mfill,br,brnew,count,name2,zerofill)
if(name2.eq.'d')call matchange5(mat,spname,siname,species,sites,fill,fac,test,k2,k3,mfill,br,brnew,count,zerofill)
call matwrite(mat,spname,siname,species,sites,name,fill,mult,k2,k3,mfill)
if(name2.eq.'e'.or.name2.eq.'f'.or.name2.eq.'r')then
write(*,'(a10,a15,1x,a9,i5,1x,a8,i5,1x,a12,i6)')'Filename: ',name,'Orig BR: ',int(br),'New BR: ',int(brnew), 'No.changes: ',count
elseif(name2.eq.'c'.or.name2.eq.'g'.or.name2.eq.'d')then
write(*,'(a10,a15,1x,a9,f7.3,1x,a8,f7.3,1x,a12,i6)')'Filename: ',name,'Orig CS: ',br,'New CS: ',brnew, 'No.changes: ',count
endif
deallocate(mat,spname,siname)
1000 continue
1001 call date_and_time(time=time)
read(time(1:2),'(i2)')time1
read(time(3:4),'(i2)')time2
read(time(5:6),'(i2)')time3
time1=time1*3600+time2*60+time3-time0
time2=int(time1/3600)
time3=int(time1/60)-time2*60
time1=time1-time3*60-time2*3600
write(*,'(a,i3,a,i3,a,i3,a)')'Runtime of program: ',&
time2,'hh',time3,'min',time1,'sec'
pause
stop
end

subroutine copy
use definitions
write(*,*)'*******************************************************'
write(*,*)'*                                                     *' 
write(*,*)'* Program MatrixChange: Version 1; 04.05.2006         *' 
write(*,*)'*                                                     *' 
write(*,*)'* Copyright Dr. Werner Ulrich                         *'
write(*,*)'*                                                     *'
write(*,*)'* The author does not take responsibility for correct *'
write(*,*)'* program run or any damages caused by the program.   *'
write(*,*)'*                                                     *'
write(*,*)'*******************************************************'
write(*,*)
return 
end

subroutine reading (tt,nu,filen)
integer nu,length,filen
character*650 text
character*50 tt(300)
length=650
text=' '
tt=' '
read(filen,'(a)',err=4,end=4) text
nu=1
i=1
do while (i.le.length-1)
if(text(i:i).ne.' ')then
do 1 j=i,length
if(text(j:j).eq.' ') then
if(nu.gt.300) goto 4 
tt(nu)=text(i:j-1)
i=j
nu=nu+1
if(i.gt.length-2.and.nu.lt.2)goto 4
goto 3
endif
1 continue
endif
i=i+1
if(i.gt.length-2.and.nu.lt.2)goto 4
3 enddo
if(nu.lt.2)goto 4
nu=nu-1
4 return
end

real*8 function norm(iseed)
real*8 a
a=0
do while(a.lt.0.000000001)
a=ran(iseed)
enddo
norm=sqrt(-2.0*dlog(a))*cos(2.0*3.14159*ran(iseed))
!write(*,*) norm
end function

subroutine matwrite(mat,spname,siname,species,sites,name,fill,mult,k2,k3,mfill)
integer species,sites,i1,k2,k3
real mat(species,sites),mfill
character*10 fill,mult
character*50 name 
character*20 spname(species),siname(sites)
i1=len_trim(name)
if(fill.eq.'r')name=name(1:i1-4)//'r.txt'
if(fill.eq.'n')name=name(1:i1-4)//'n.txt'
open(3,file=name,status='replace')
if(mult.eq.'m')write(4,'(a)')name
write(3,'(a1,1x,<sites>(a3,1x))')'S',(siname(j),j=1,sites)
!call spaces (sites)
do 8 i=1,species
i1=len_trim(spname(i))
write(3,'(a,1x,<sites>(f3.1,1x))')spname(i)(1:i1),(mat(i,j),j=1,sites)
!call spaces (sites)
8 continue
close(3)
if(special.eq.'yes')write(9,'(a15,1x,4(i5,1x),f5.3)')name,species,sites,k2,k3,mfill
return
end

subroutine spaces(sa)
integer length,sa
character*650 text
text=' '
length=650
backspace (3)
read(3,'(a<length>)') text
backspace(3)
write(*,*) text(1:60)
do 1 i=1,length
if(text(i:i).eq.' ')then
k=0
do while (text(i+1:i+1).eq.' ')
k=k+1
if(k.gt.length-i) goto 4
do 2 j=i+1,length-1
text(j:j)=text(j+1:j+1)
2 continue
enddo
endif
1 continue
4 do 3 j=1,length-1
text(j:j)=text(j+1:j+1)
3 continue
do 5 j=1,length
if(text(j:j).eq.' '.and.text(j+1:j+1).eq.' ')then
length=j-1
goto 6
endif
5 continue
6 write(3,'(a<length>)')text(1:length)
!write(*,*) text
return
end

subroutine matchange1(mat,spname,siname,species,sites,fill,fac,test,k2,k3,mfill,br,brnew,count)
integer species,sites,count
real mat(species,sites),fac,mfill,br,brnew
integer row(species),col(sites)
integer, allocatable:: hole(:,:),pres(:,:)
character*10 fill,test
character*20 spname(species),siname(sites)
call sortrow(mat,row,spname,species,sites)
call sortcol(mat,col,siname,species,sites)
if(fill.eq.'n')then
if(test.eq.'yes')write(8,'(a)')'Original matrix'
br=0
brnew=0
ka=species*sites
kp=0
do 358 i=1,species
if(test.eq.'yes')write(8,'(a4,1x,<sites>(f3.1,1x),i4)')spname(i),(mat(i,j),j=1,sites),row(i)
do 357 k1=1,sites
if(mat(i,k1).gt.0)kp=kp+1
357 continue
358 continue
ka=max(ka-kp,kp)
mfill=kp/real(ka)
if(test.eq.'yes')write(8,'(a)')' '
if(test.eq.'yes')write(8,'(5x,<sites>(i3,1x))')(col(j),j=1,sites)
if(test.eq.'yes')write(8,'(a)')' '
if(ka.lt.1)goto 200
allocate (hole(ka,2),pres(ka,2))
k2=0
k3=0
do 350 i=1,species
do 351 k1=1,sites
if(k1.le.row(i).and.mat(i,k1).eq.0)then
k2=k2+1
hole(k2,1)=i
hole(k2,2)=k1
elseif(k1.gt.row(i).and.mat(i,k1).gt.0)then
k3=k3+1
pres(k3,1)=i
pres(k3,2)=k1
endif
351 continue
350 continue
if(test.eq.'yes')write(8,'(a,1x,i5,1x,a,1x,i5)')'Holes,',k2,'Presences, ',k3
if(k2.lt.1) goto 352
k5=int(fac*k2)
!if(k5.lt.1)k5=1
do while(k5.gt.0)
i=int(ran(iseed)*k2)+1
mat(hole(i,1),hole(i,2))=1.0
if(test.eq.'yes')write(8,'(a,i3,1x,i3)')'Hole ',hole(i,1),hole(i,2)
k5=k5-1
enddo
352 if(k3.lt.1) goto 353
k4=int(fac*k3)
!if(k4.lt.2)k4=1
do while(k4.gt.0)
j=int(ran(iseed)*k3)+1
mat(pres(j,1),pres(j,2))=0
if(test.eq.'yes')write(8,'(a,i3,1x,i3)')'Pres ',pres(j,1),pres(j,2)
k4=k4-1
enddo
if(test.eq.'yes')write(8,'(a)')'More nested matrix'
do 359 i=1,species
if(test.eq.'yes')write(8,'(a4,1x,<sites>(f3.1,1x))')spname(i),(mat(i,j),j=1,sites)
359 continue
353 deallocate(hole,pres)
elseif(fill.eq.'r')then
if(test.eq.'yes')write(8,'(a)')'Original matrix'
ka=species*sites
kp=0
do 368 i=1,species
if(test.eq.'yes')write(8,'(a4,1x,<sites>(f3.1,1x))')spname(i),(mat(i,j),j=1,sites)
do 367 k1=1,sites
if(mat(i,k1).gt.0)kp=kp+1
367 continue
368 continue
if(ka.lt.1)goto 200
ka=max(ka-kp,kp)
mfill=kp/real(ka)
allocate(hole(ka,2),pres(ka,2))
k2=0
k3=0
do 360 i=1,species
do 361 k1=1,sites
if(k1.le.row(i).and.mat(i,k1).gt.0)then
k2=k2+1
hole(k2,1)=i
hole(k2,2)=k1
elseif(k1.gt.row(i).and.mat(i,k1).eq.0)then
k3=k3+1
pres(k3,1)=i
pres(k3,2)=k1
endif
361 continue
360 continue
if(test.eq.'yes')write(8,'(a,1x,i5,1x,a,1x,i5)')'Occurrences,',k2,'Absences, ',k3
if(k2.lt.1) goto 362
k5=int(fac*k2)
!if(k5.lt.1)k5=1
do while(k5.gt.0)
i=int(ran(iseed)*k2)+1
mat(hole(i,1),hole(i,2))=0
if(test.eq.'yes')write(8,'(a,i3,1x,i3)')'Hole ',hole(i,1),hole(i,2)
k5=k5-1
enddo
362 if(k3.lt.1) goto 363
k4=int(fac*k3)
!if(k4.lt.2)k4=1
do while(k4.gt.0)
j=int(ran(iseed)*k3)+1
mat(pres(j,1),pres(j,2))=1.0
if(test.eq.'yes')write(8,'(a,i3,1x,i3)')'Pres ',pres(j,1),pres(j,2)
k4=k4-1
enddo
if(test.eq.'yes')write(8,'(a)')'Less nested matrix'
do 369 i=1,species
if(test.eq.'yes')write(8,'(a4,1x,<sites>(f3.1,1x))')spname(i),(mat(i,j),j=1,sites)
369 continue
363 deallocate(hole,pres)
endif
200 return
end

subroutine sortrow(field,row,spname,sp,si)
integer sp,si
integer row(sp),a
real field(sp,si),an(si)
character*20,spname(sp),b
3 row=0
do 10 i1=1,sp
do 11 j1=1,si
if(field(i1,j1).gt.0)row(i1)=row(i1)+1
11 continue
10 continue
do 2 j1=1,sp-1
do 1 i1=j1+1,sp
if(row(i1).gt.row(j1))then
do 5 k1=1,si
an(k1)=field(j1,k1)
field(j1,k1)=field(i1,k1)
field(i1,k1)=an(k1)
5 continue
a=row(j1)
b=spname(j1)
row(j1)=row(i1)
spname(j1)=spname(i1)
row(i1)=a
spname(i1)=b
endif
1 continue
2 continue
return
end

subroutine sortcol(field,col,siname,sp,si)
integer sp,si
real field(sp,si),an(sp)
integer col(si),a
character*20,siname(si),b
3 col=0
do 10 i1=1,si
do 11 j1=1,sp
if(field(j1,i1).gt.0)col(i1)=col(i1)+1
11 continue
10 continue
do 2 j1=1,si-1
do 1 i1=j1+1,si
if(col(i1).gt.col(j1))then
do 5 k1=1,sp
an(k1)=field(k1,j1)
field(k1,j1)=field(k1,i1)
field(k1,i1)=an(k1)
5 continue
a=col(j1)
b=siname(j1)
col(j1)=col(i1)
siname(j1)=siname(i1)
col(i1)=a
siname(i1)=b
endif
1 continue
2 continue
return
end

subroutine matread
use definitions
t=' '
read(filen,'(a)')t
call reading (tt,nu,filen)
sites=nu-1
allocate (siname(sites))
rewind(1)
call reading (tt,nu,filen)
do 1 j=2,sites+1
read(tt(j),'(a20)',err=2,end=2)siname(j-1)
1 continue
2 species=0
do while (species.ge.0)
read(1,'(a1)',err=3,end=3)t
if(t.eq.' ')goto 3
species=species+1
enddo
3 allocate (mat(species,sites),spname(species))
mat=0
rewind(filen)
read(filen,'(a1)',err=10,end=10)t
tt=' '
nu=0
do 4 i=1,species
call reading (tt,nu,filen)
if(tt(1).eq.' ')goto 7
read(tt(1),'(a20)')spname(i)
do 5 j=2,nu
read(tt(j),*)mat(i,j-1)
5 continue
!6 write(8,'(a4,1x,<sites>(f3.1,1x))')spname(i),(mat(i,j),j=1,sites)
4 continue
7 return
10 write(*,*)'Error'
end


subroutine matchange2(mat,spname,siname,species,sites,fill,fac,test,k2,k3,mfill,br,brnew,count,zerofill)
integer species,sites,ifill,icheck,count
real mat(species,sites),fac,mfill,br,brnew
integer row(species),col(sites)
character*10 fill,test,zerofill
character*20 spname(species),siname(sites)
call sortrow(mat,row,spname,species,sites)
call sortcol(mat,col,siname,species,sites)
if(test.eq.'yes')write(8,'(a)')'Original matrix'
do 8 i=1,species
if(test.eq.'yes')write(8,'(a4,1x,<sites>(f3.1,1x),i4)')spname(i),(mat(i,j),j=1,sites),row(i)
8 continue
if(zerofill.eq.'yes')then
do 19 i=1,species
do 21 j=1,sites
if(mat(i,j).gt.0)goto 19
21 continue
k=int(ran(iseed)*sites)+1
mat(i,k)=1.0
write(*,'(a,i4,a,i4)')'Empty columns/row filled once: Row: ',i,' Column: ',k
19 continue
do 17 i=1,sites
do 18 j=1,species
if(mat(j,i).gt.0)goto 17
18 continue
k=int(ran(iseed)*species)+1
mat(k,i)=1.0
write(*,'(a,i4,a,i4)') 'Empty columns/row filled once: Row: ',k,' Column: ',i
17 continue
endif
br=0
brnew=0
do 1 i=1,species
if(row(i).eq.0)goto 11
do 2 j=1,row(i)
if(mat(i,j).eq.0)br=br+1
2 continue
1 continue
mfill=fac*br
icheck=0
count=0
ifill=100*species*sites
do while(count.le.mfill.and.icheck.lt.ifill)
icheck=icheck+1
i1=int(ran(iseed)*species)+1
if(fill.eq.'n')then
do 3 j=1,species*sites
k=int(ran(iseed)*row(i1))+1
if(mat(i1,k).eq.0)then
do 4 j1=1,species*sites
k1=int(ran(iseed)*(sites-row(i1)))+1+row(i1)
if(mat(i1,k1).ne.0)then
mat(i1,k)=1.0
mat(i1,k1)=0
count=count+1
goto 5
endif
4 continue
endif
3 continue
endif
if(fill.eq.'r')then
do 9 j=1,species*sites
k=int(ran(iseed)*(sites-row(i1)))+1+row(i1)
if(mat(i1,k).eq.0)then
do 6 j1=1,species*sites
k1=int(ran(iseed)*row(i1))+1
if(mat(i1,k1).eq.1.0)then
mat(i1,k)=1.0
mat(i1,k1)=0
count=count+1
goto 5
endif
6 continue
endif
9 continue
endif
5 enddo
11 do 10 i=1,species
do 20 j=1,row(i)
if(mat(i,j).eq.0)brnew=brnew+1
20 continue
10 continue
return
end

subroutine matchange3(mat,spname,siname,species,sites,fill,fac,test,k2,k3,mfill,br,brnew,count,zerofill)
integer species,sites,kswap,count,sp,si
real mat(species,sites),fac,mfill,mat1(species,sites),br,brnew,brold
integer row(species),col(sites)
character*10 fill,test,zerofill
character*20 spname(species),siname(sites)
call sortrow(mat,row,spname,species,sites)
call sortcol(mat,col,siname,species,sites)
if(test.eq.'yes')write(8,'(a)')'Original matrix'
do 8 i=1,species
if(test.eq.'yes')write(8,'(a4,1x,<sites>(f3.1,1x),i4)')spname(i),(mat(i,j),j=1,sites),row(i)
8 continue
if(zerofill.eq.'yes')then
do 19 i=1,species
do 21 j=1,sites
if(mat(i,j).gt.0)goto 19
21 continue
k=int(ran(iseed)*sites)+1
mat(i,k)=1.0
write(*,'(a,i4,a,i4)')'Empty columns/row filled once: Row: ',i,' Column: ',k
19 continue
do 17 i=1,sites
do 18 j=1,species
if(mat(j,i).gt.0)goto 17
18 continue
k=int(ran(iseed)*species)+1
mat(k,i)=1.0
write(*,'(a,i4,a,i4)') 'Empty columns/row filled once: Row: ',k,' Column: ',i
17 continue
endif
brold=0
do 16 i=1,species
do 15 j=1,row(i)
if(mat(i,j).eq.0)brold=brold+1
15 continue
16 continue
mfill=fac*brold
jj=0
kswap=0
count=0
brnew=brold
mat1=mat
do while (kswap.lt.mfill)
!write(*,*)'Simulation: ',kswap,mfill
jj=jj+1
if(jj.gt.100*species*sites)goto 31
k1=int(species*ran(iseed))+1
k2=int(sites*ran(iseed))+1
35 k3=int(species*ran(iseed))+1
if(k3.eq.k1)goto 35
36 k4=int(sites*ran(iseed))+1
if(k4.eq.k2)goto 36
if(fill.eq.'n')then
if((mat(k1,k2).ne.0.and.mat(k3,k4).ne.0).or.(mat(k3,k2).ne.0.and.mat(k1,k4).ne.0))then
if((mat(k1,k2).eq.0.and.mat(k3,k4).eq.0).or.(mat(k3,k2).eq.0.and.mat(k1,k4).eq.0))then
kswap=kswap+1
a=mat(k1,k2)
mat(k1,k2)=mat(k1,k4)
mat(k1,k4)=a
a=mat(k3,k2)
mat(k3,k2)=mat(k3,k4)
mat(k3,k4)=a
count=count+1
br=0
do 1 i=1,species
do 2 j=1,row(i)
if(mat(i,j).eq.0)br=br+1
2 continue
1 continue
if(br.gt.0.and.br.lt.brnew)then
mat1=mat
brnew=br
!write(*,*) count,br
endif
endif
endif
elseif(fill.eq.'r')then
if((mat(k1,k2).ne.0.and.mat(k3,k4).ne.0).or.(mat(k3,k2).ne.0.and.mat(k1,k4).ne.0))then
if((mat(k1,k2).eq.0.and.mat(k3,k4).eq.0).or.(mat(k3,k2).eq.0.and.mat(k1,k4).eq.0))then
kswap=kswap+1
a=mat(k1,k2)
mat(k1,k2)=mat(k1,k4)
mat(k1,k4)=a
a=mat(k3,k2)
mat(k3,k2)=mat(k3,k4)
mat(k3,k4)=a
count=count+1
br=0
do 11 i=1,species
do 12 j=1,row(i)
if(mat(i,j).eq.0)br=br+1
12 continue
11 continue
if(br.gt.0.and.br.gt.brnew)then
mat1=mat
brnew=br
!write(*,*) count,br
endif
endif
endif
endif
!endif
enddo
31 if(count.gt.0)mat=mat1
brnew=0
do 10 i=1,species
do 20 j=1,row(i)
if(mat(i,j).eq.0)brnew=brnew+1
20 continue
10 continue
br=brold
return
end

subroutine matchange4(mat,spname,siname,species,sites,fill,fac,test,k2,k3,mfill,br,brnew,count,name2,zerofill)
integer species,sites,kswap,count,sp,si
real mat(species,sites),fac,mfill,mat1(species,sites),a,br,brnew,brold
integer row(species),col(sites)
character*10 fill,test,zerofill
character*50 name2
character*20 spname(species),siname(sites)
call sortrow(mat,row,spname,species,sites)
call sortcol(mat,col,siname,species,sites)
if(test.eq.'yes')write(8,'(a)')'Original matrix'
do 8 i=1,species
if(test.eq.'yes')write(8,'(a4,1x,<sites>(f3.1,1x),i4)')spname(i),(mat(i,j),j=1,sites),row(i)
8 continue
if(zerofill.eq.'yes')then
do 19 i=1,species
do 20 j=1,sites
if(mat(i,j).gt.0)goto 19
20 continue
k=int(ran(iseed)*sites)+1
mat(i,k)=1.0
write(*,'(a,i4,a,i4)')'Empty columns/row filled once: Row: ',i,' Column: ',k
19 continue
do 17 i=1,sites
do 18 j=1,species
if(mat(j,i).gt.0)goto 17
18 continue
k=int(ran(iseed)*species)+1
mat(k,i)=1.0
write(*,'(a,i4,a,i4)') 'Empty columns/row filled once: Row: ',k,' Column: ',i
17 continue
endif
a=0
do 16 i=1,species-1
do 160 i1=i+1,species
brold=0
do 15 j=1,sites
if(mat(i,j).gt.0.and.mat(i1,j).gt.0)brold=brold+1
15 continue
a=a+(row(i)-brold)*(row(i1)-brold)
!write(*,*)i,i1,a,col(i),row(i1)
!pause
160 continue
16 continue
brold=2*a/(species*(species-1))
mfill=fac*species*sites
jj=0
kswap=0
count=0
brnew=brold
mat1=mat
do while (count.lt.mfill)
kswap=kswap+1
!write(*,*)'Simulation: ',count,kswap,mfill,species*sites
if(kswap.gt.species*sites)goto 31
k1=int(species*ran(iseed))+1
k2=int(sites*ran(iseed))+1
35 k3=int(species*ran(iseed))+1
if(k3.eq.k1)goto 35
36 k4=int(sites*ran(iseed))+1
if(k4.eq.k2)goto 36
if(fill.eq.'r')then
if(.not.((mat(k1,k2).ne.0.and.mat(k3,k4).ne.0).or.(mat(k3,k2).ne.0.and.mat(k1,k4).ne.0)))then
if(.not.((mat(k1,k2).eq.0.and.mat(k3,k4).eq.0).or.(mat(k3,k2).eq.0.and.mat(k1,k4).eq.0)))then
!write(*,*) 'or'
!write(*,*) mat(k1,k2),mat(k1,k4)
!write(*,*) mat(k3,k2),mat(k3,k4)
if(name2.eq.'c')then
if((mat(k1,k2).gt.0.and.mat(k1,k4).gt.0).or.(mat(k3,k2).gt.0.and.mat(k3,k4).gt.0))then
a=mat(k1,k2)
mat(k1,k2)=mat(k3,k2)
mat(k3,k2)=a
else
a=mat(k1,k2)
mat(k1,k2)=mat(k1,k4)
mat(k1,k4)=a
endif
!write(*,*) 'new'
!write(*,*) mat(k1,k2),mat(k1,k4)
!write(*,*) mat(k3,k2),mat(k3,k4)
else
if((mat(k1,k2).gt.0.and.mat(k3,k2).gt.0).or.(mat(k1,k4).gt.0.and.mat(k3,k4).gt.0))then
a=mat(k1,k2)
mat(k1,k2)=mat(k1,k4)
mat(k1,k4)=a
!write(*,*) 'new'
!write(*,*) mat(k1,k2),mat(k1,k4)
!write(*,*) mat(k3,k2),mat(k3,k4)
endif
endif 
a=0
do 161 i=1,species-1
do 162 i1=i+1,species
br=0
do 151 j=1,sites
if(mat(i,j).gt.0.and.mat(i1,j).gt.0)br=br+1
151 continue
a=a+(row(i)-br)*(row(i1)-br)
162 continue
161 continue
br=2*a/(species*(species-1))
if(br.gt.0.and.br.gt.brnew)then
mat1=mat
brnew=br
count=count+1
endif
endif
endif
elseif(fill.eq.'n')then
if((mat(k1,k2).ne.0.and.mat(k3,k4).ne.0).or.(mat(k3,k2).ne.0.and.mat(k1,k4).ne.0))then
if((mat(k1,k2).eq.0.and.mat(k3,k4).eq.0).or.(mat(k3,k2).eq.0.and.mat(k1,k4).eq.0))then
!write(*,*) 'or'
!write(*,*) mat(k1,k2),mat(k1,k4)
!write(*,*) mat(k3,k2),mat(k3,k4)
if(name2.eq.'c')then
a=ran(iseed)
if(a.gt.0.5)then
a=mat(k1,k2)
mat(k1,k2)=mat(k3,k2)
mat(k3,k2)=a
else
a=mat(k1,k2)
mat(k1,k2)=mat(k1,k4)
mat(k1,k4)=a
endif
else
a=mat(k1,k2)
mat(k1,k2)=mat(k1,k4)
mat(k1,k4)=a
endif 
!write(*,*) 'new'
!write(*,*) mat(k1,k2),mat(k1,k4)
!write(*,*) mat(k3,k2),mat(k3,k4)
count=count+1
a=0
do 171 i=1,species-1
do 172 i1=i+1,species
br=0
do 181 j=1,sites
if(mat(i,j).gt.0.and.mat(i1,j).gt.0)br=br+1
181 continue
a=a+(row(i)-br)*(row(i1)-br)
172 continue
171 continue
br=2*a/(species*(species-1))
if(br.gt.0.and.br.lt.brnew)then
mat1=mat
brnew=br
count=count+1
endif
endif
endif
endif
enddo
31 if(count.gt.0)mat=mat1
a=0
do 165 i=1,species-1
do 166 i1=i+1,species
br=0
do 153 j=1,sites
if(mat(i,j).gt.0.and.mat(i1,j).gt.0)br=br+1
153 continue
a=a+(row(i)-br)*(row(i1)-br)
166 continue
165 continue
brnew=2*a/(species*(species-1))
br=brold
return
end


subroutine matchange5(mat,spname,siname,species,sites,fill,fac,test,k2,k3,mfill,br,brnew,count,zerofill)
integer species,sites,kswap,count,sp,si
real mat(species,sites),fac,mfill,mat1(species,sites),a,br,brnew,brold
integer row(species),col(sites)
character*10 fill,test,zerofill
character*20 spname(species),siname(sites)
call sortrow(mat,row,spname,species,sites)
call sortcol(mat,col,siname,species,sites)
if(test.eq.'yes')then
write(8,'(a)')'Original matrix'
do 8 i=1,species
write(8,'(a4,1x,<sites>(f3.1,1x),i4)')spname(i),(mat(i,j),j=1,sites),row(i)
8 continue
endif
if(zerofill.eq.'yes')then
do 19 i=1,species
do 20 j=1,sites
if(mat(i,j).gt.0)goto 19
20 continue
k=int(ran(iseed)*sites)+1
mat(i,k)=1.0
write(*,'(a,i4,a,i4)')'Empty columns/row filled once: Row: ',i,' Column: ',k
19 continue
do 17 i=1,sites
do 18 j=1,species
if(mat(j,i).gt.0)goto 17
18 continue
k=int(ran(iseed)*species)+1
mat(k,i)=1.0
write(*,'(a,i4,a,i4)') 'Empty columns/row filled once: Row: ',k,' Column: ',i
17 continue
endif
a=0
do 16 i=1,species-1
do 160 i1=i+1,species
brold=0
do 15 j=1,sites
if(mat(i,j).gt.0.and.mat(i1,j).gt.0)brold=brold+1
15 continue
a=a+(row(i)-brold)*(row(i1)-brold)
!write(*,*)i,i1,a,col(i),row(i1)
!pause
160 continue
16 continue
brold=2*a/(species*(species-1))
mfill=fac*species*sites
jj=0
kswap=0
count=0
brnew=brold
mat1=mat
do while (count.lt.mfill)
!write(*,*)'Simulation: ',count,kswap,mfill,mfill*species*sites
kswap=kswap+1
if(kswap.gt.10*mfill)goto 31
k1=int(species*ran(iseed))+1
k2=int(sites*ran(iseed))+1
35 k3=int(species*ran(iseed))+1
if(k3.eq.k1)goto 35
36 k4=int(sites*ran(iseed))+1
if(k4.eq.k2)goto 36
if((mat(k1,k2).ne.0.and.mat(k3,k4).ne.0).or.(mat(k3,k2).ne.0.and.mat(k1,k4).ne.0))then
if((mat(k1,k2).eq.0.and.mat(k3,k4).eq.0).or.(mat(k3,k2).eq.0.and.mat(k1,k4).eq.0))then
!write(*,*) 'or'
!write(*,*) mat(k1,k2),mat(k1,k4)
!write(*,*) mat(k3,k2),mat(k3,k4)
a=mat(k1,k2)
mat(k1,k2)=mat(k1,k4)
mat(k1,k4)=a
a=mat(k3,k2)
mat(k3,k2)=mat(k3,k4)
mat(k3,k4)=a
a=0
do 161 i=1,species-1
do 162 i1=i+1,species
br=0
do 151 j=1,sites
if(mat(i,j).gt.0.and.mat(i1,j).gt.0)br=br+1
151 continue
a=a+(row(i)-br)*(row(i1)-br)
162 continue
161 continue
br=2*a/(species*(species-1))
!write(*,*) 'new'
!write(*,*) mat(k1,k2),mat(k1,k4)
!write(*,*) mat(k3,k2),mat(k3,k4)
if(fill.eq.'n'.and.br.lt.brnew)then
!write(*,*)br,brnew
mat1=mat
brnew=br
count=count+1
elseif(fill.eq.'r'.and.br.gt.brnew)then
!write(*,*)br,brnew
mat1=mat
brnew=br
count=count+1
endif
endif
endif
enddo
31 if(count.gt.0)mat=mat1
!do 19 i=1,species
!do 20 j=1,sites
!if(mat(i,j).gt.0)goto 19
!20 continue
!k=int(ran(iseed)*sites)+1
!mat(i,k)=1.0
!write(*,'(a,i4,a,i4)') 'Empty columns/row filled once: Row: ',k,' Column: ',i
!19 continue
!do 17 i=1,sites
!do 18 j=1,species
!if(mat(j,i).gt.0)goto 17
!18 continue
!k=int(ran(iseed)*species)+1
!mat(k,i)=1.0
!write(*,'(a,i4,a,i4)') 'Empty columns/row filled once: Row: ',k,' Column: ',i
!17 continue
a=0
do 165 i=1,species-1
do 166 i1=i+1,species
br=0
do 153 j=1,sites
if(mat(i,j).gt.0.and.mat(i1,j).gt.0)br=br+1
153 continue
a=a+(row(i)-br)*(row(i1)-br)
166 continue
165 continue
brnew=2*a/(species*(species-1))
br=brold
return
end