!Last change 08.05.2006
Module definitions
real*8 ran1
integer time1,time2,time3,time0,iseed,filen,length,nu
integer sp,si,iter,iter1,empty,ifill,jfill,n0,n1,nc,n0or,n1or,ncor,br,bror,iout,kswap,rep,rep1
real temp,fill,meanran,varran,skewran,tempor,tempup,tempdown,sadslope,mini,tempz,n0z,n1z,ncz,utz,n0mean,n1mean,ncmean,utmean,n0var,n1var,ncvar,utvar
real brz,brmean,brvar,uaz,uamen,uavar,upz,upmean,upvar,uaup,uadown,uaskew,upup,updown,upskew,ua,uaor,up,upor,ut,utor
real n0skew,n1skew,ncskew,n0up,n1up,ncup,utup,n0down,n1down,ncdown,utdown,brskew,brup,brdown
real, allocatable:: mat(:,:),mat1(:,:),mat2(:,:),tempsp(:,:),tempsi(:,:),tempspor(:,:),tempsior(:,:)
real, allocatable:: tempran(:),n0sim(:),n1sim(:),ncsim(:),utsim(:),brsim(:),uasim(:),upsim(:)
integer, allocatable:: row(:),col(:),def(:),rowor(:),color(:)
character*10 time
character*10 maxpack,dist,dist1,rand,special
character*650 text
character*50 tt(300),name,name1,t
character*50, allocatable:: spname(:),siname(:),spnameor(:),sinameor(:)
end module definitions

program Nestedness
use definitions
real*8 norm
real mean, skewness,variance,a
length=650
filen=1
text=' '
iter=0
rep=25000
rep1=5000
name=' '
name1=' '
iter1=100000
maxpack='s'
dist='yes'
dist1='yes'
special='no'
call date_and_time(time=time)
read(time(1:2),'(i2)')time1
read(time(3:4),'(i2)')time2
read(time(5:6),'(i2)')time3
time0=time1*3600+time2*60+time3
call random_seed
call random_number(ran1)
iseed=int(ran1*(10**9))
call copy
if(special.eq.'yes')then
open(9,file='special.txt',status='replace')
write(9,'(a14,1x,7(a9,1x))')'File','BR','SimBR','StdDevBR','MT','SimMT','StdDevMT','Occur'
endif
1 write(*,*)'Name of input file with extension. File has to have EcoSim format.'
write(*,*)'If batch run leave blank.'
read(*,'(a)',advance='yes',eor=2)name
2 if(name.ne.' ')then
open(1,file=name,status='old',err=1)
read(1,'(a)',err=1000,end=1000)t
iter1=1
else
3 write(*,*)'Name of file names file (with extension). First line has to be a comment line'
read(*,*)name1
open(2,file=name1,status='old',err=3)
read(2,'(a)')t
iter1=100000
endif
t=' '
write(*,*)'Name of output file (with extension), default = Output.txt'
read(*,'(a)',advance='yes',eor=80)t
80 if(t.eq.' ')t='Output.txt'
open(3,file=t,status='replace')
t=' '
write(*,*)'Name of matrix file (with extension), default = Matrix.txt'
read(*,'(a)',advance='yes',eor=81)t
81 if(t.eq.' ')t='Matrix.txt'
open(4,file=t,status='replace')
if(dist.eq.'yes')then
t=' '
write(*,*)'Name of cell temperatures file (with extension), default = Unexp.txt'
read(*,'(a)',advance='yes',eor=82)t
82 if(t.eq.' ')t='Unexp.txt'
open(7,file=t,status='replace')
endif
it=0
6 write(*,*)'Null model for randomization:'
write(*,*)'Fixed row and column constraints sequential swap (s),'
write(*,*)'no constraints (equiprobable row and columns)(e),'
write(*,*)'fixed row and equiprobable column constraints (f),'
write(*,*)'fixed column and equiprobable row constraints (c),'
write(*,*)'random sampling according to observed frequencies of occurrence (o),'
write(*,*)'or random sampling from a lognormal distribution (l)'
read(*,'(a1)',err=6)rand
if(rand.ne.'f'.and.rand.ne.'s'.and.rand.ne.'l'.and.rand.ne.'e'.and.rand.ne.'c'.and.rand.ne.'o')goto 6
if(rand.eq.'l')then
7 write(*,*)'Shape parameter of the lognormal distribution'
write(*,*)'Default = 0.2 (canonical lognormal)'
read(*,'(f8.5)',advance='yes',eor=111)sadslope
111 if(sadslope.eq.0)sadslope=0.2
sadslope=1.0/(2.0*sadslope)
endif
5 write(*,*)'Number of iterations for computing standard deviations of the null model'
write(*,*)'Default=100'
read(*,'(i6)',err=61)iter
61 if(iter.lt.0)goto 5
if(iter.eq.0)iter=100
allocate(tempran(iter),n0sim(iter),n1sim(iter),ncsim(iter),utsim(iter),brsim(iter),uasim(iter),upsim(iter))
t=' '
51 write(*,*)'Minimum distance to borderline. Cells nearer to the borderline will be'
write(*,*)'exlcuded from the computation of the matrix temperature (default = 0.5)'
read(*,'(a6)',eor=52,advance='yes')t
52 if(t.eq.' ')mini=0.5
if(t.ne.' ')read(t,'(f6.3)',err=51)mini
if(mini.lt.0)goto 51
write(*,*)'How to pack the matrix?' 
write(*,*)'According to richness (s; default) or according to matrix temperature (t)'
read(*,'(a)',advance='yes',eor=41)maxpack
if(maxpack.ne.'t')maxpack='s'
41 if(rand.ne.'l')write(3,'(a12,a3,1x,a14,a3,1x,a12,i4,1x,a18,f6.3)')&
'Null model: ',rand,'Packing type: ',maxpack,'Iterations: ',iter,'Minimum distance: ',mini
if(rand.ne.'l')write(4,'(a12,a3,1x,a14,a3,1x,a12,i4,1x,a18,f6.3)')&
'Null model: ',rand,'Packing type: ',maxpack,'Iterations: ',iter,'Minimum distance: ',mini
if(rand.eq.'l')write(3,'(a12,a3,1x,a14,a3,1x,a12,i4,1x,a18,f5.3,1x,a18,f6.3)')&
'Null model: ',rand,'Packing type: ',maxpack,'Iterations: ',iter,'Lognormal shape: ',1.0/(2.0*sadslope),'Minimum distance: ',mini
if(rand.eq.'l')write(4,'(a12,a3,1x,a14,a3,1x,a12,i4,1x,a18,f5.3,1x,a18,f6.3)')&
'Null model: ',rand,'Packing type: ',maxpack,'Iterations: ',iter,'Lognormal shape: ',1.0/(2.0*sadslope),'Minimum distance: ',mini
write(3,'(a)')' '
write(4,'(a)')' '
do 200 ijk=1,iter1
4 if(name1.ne.' ')then
read(2,'(a50)',err= 1000, end=1001)name
open(1,file=name,status='old',err=4)
read(1,'(a)',err=4)t
endif
call reading
if(nu.lt.1)then
write(*,'(a,a15)')'Format error encountered in file ',name
if(name1.ne.' ') goto 4
if(name1.eq.' ') goto 1000
endif
backspace(1)
si=nu-2
if(si.lt.2)then
if(name1.ne.' ')then
write(*,'(a,a15)')'Too few sites in file ',name
goto 4
else
goto 1000
endif
endif
i=1
do while (i.ge.1)
read(1,'(a)',err=14,end=14)t
if(t.ne.' ')i=i+1
enddo
14 sp=i-1
if(sp.lt.2)then
if(name1.ne.' ')then
write(*,'(a,a15)')'Too few species in file ',name
goto 4
else
goto 1000
endif
endif
rewind (1)
allocate(mat(sp,si),mat1(sp,si),row(sp),col(si),def(si),tempsp(sp,2),tempsi(si,2),tempspor(sp,2),tempsior(si,2),spname(sp),siname(si),rowor(sp),color(si),spnameor(sp),sinameor(si))
if(dist1.eq.'yes')then
allocate(mat2(sp,si))
dist=dist1
mat2=0
endif
tempran=0
n0sim=0
n1sim=0
ncsim=0
utsim=0
uasim=0
upsim=0
brsim=0
n0or=0
n1or=0
ncor=0
utor=0
uaor=0
upor=0
bror=0
tempor=0
col=0
row=0
rowor=0
color=0
mat=0
mat1=0
tempspor=0
tempsior=0
def=0
spname=' '
siname=' '
empty=0
fill=0
call reading
do 99 i=2,si+1
read(tt(i),'(a50)',end=98,err=98)siname(i-1)
99 continue
98 do 100 i=1,sp
call reading
read(tt(1),'(a50)',end=103,err=103)spname(i)
do 101 j=2,si+1
read(tt(j),*,end=103,err=103)a
if(a.gt.0)mat(i,j-1)=1
if(a.gt.0)empty=empty+1
101 continue
103 ii=ii
100 continue
fill=empty
fill=fill/(sp*si)
if(fill.le.1.0/(sp*si).or.fill.ge.sp*si)then
write(*,*)'Matrix fill too low or too high'
goto 200
endif
mat1=mat
call sort(mat1,row,spname,sp,si,fill,maxpack,ifill,jfill,mini)
call sort1(mat1,col,siname,sp,si,fill,maxpack,ifill,jfill,mini)
call measures (mat1,row,col,sp,si,n0,n1,ut,nc,br,ua,up)
n0or=n0
n1or=n1
ncor=nc
utor=ut
uaor=ua
upor=up
bror=br
if(maxpack.eq.'t')call sorttemp(mat1,row,spname,sp,si,fill,ifill,jfill,mini)
if(maxpack.eq.'t')call sorttemp1(mat1,col,siname,sp,si,fill,ifill,jfill,mini)
if(dist.eq.'yes')then
write(7,'(a15,1x,a8,1x,i4,1x,a8,1x,i4)')name,'Species:',sp,'Sites:',si
write(7,'(2(a5,1x),6(a7,1x))')'RowF','ColF','X','Y','a1','a2','RowI','ColI'
endif
call temperature
tempor=temp
tempspor=tempsp
tempsior=tempsi
rowor=row
color=col
spnameor=spname
sinameor=siname
write(*,'(a15,1x,a8,1x,i4,1x,a8,1x,i4,1x,a13,1x,f6.2)')name,'Species:',sp,'Sites:',si,'Temperature: ',tempor 
write(4,'(a,a)')'Packed matrix: ',name
write(4,'(a)')' '
write(4,'(13x,<si>(a3,1x))')(siname(j),j=1,si)
write(4,'(a)')' '
do 23 i=1,sp
write(4,'(a12,1x,<si>(i3,1x),3x,i4)')spname(i),(int(mat1(i,j)),j=1,si),row(i)
23 continue
write(4,'(a)')' '
write(4,'(13x,<si>(i3,1x))')(col(j),j=1,si)
if(dist.eq.'yes')then
write(7,'(a,1x,a13,1x,f6.2)')'Packed matrix with u-values of unexpectedness: ','Temperature: ',tempor 
write(7,'(a)')' '
write(7,'(13x,<si>(a6,1x))')(siname(j),j=1,si)
write(7,'(a)')' '
do 24 i=1,sp
write(7,'(a12,1x,<si>(f6.4,1x),3x,f6.4)')spname(i),(mat2(i,j),j=1,si),tempsp(i,1)*0.0004145*si
24 continue
write(7,'(a)')' '
write(7,'(13x,<si>(f6.4,1x))')(tempsi(j,1)*0.0004145*sp,j=1,si)
write(7,'(a)')' '
!close(7)
deallocate(mat2)
dist='no'
endif
if(iter.eq.0) goto 22
mat1=mat
def=col
if(rand.eq.'s')call swap (mat1,sp,si,rep,iseed,kswap)
iout=0
do 20 i=1,iter
row=0
col=0
if(rand.eq.'e')call equi (mat1,sp,si,iseed,empty)
if(rand.eq.'s')call swap (mat1,sp,si,rep1,iseed,kswap)
if(rand.eq.'f')call fixrow(mat1,sp,si,rep,iseed)
if(rand.eq.'c')call fixcol(mat1,sp,si,rep,iseed)
if(rand.eq.'l')call sample (mat1,rowor,def,sp,si,iseed,sadslope,rand,iout)
if(rand.eq.'o')call sample (mat1,rowor,def,sp,si,iseed,sadslope,rand,iout)
call sort(mat1,row,spname,sp,si,fill,maxpack,ifill,jfill,mini)
call sort1(mat1,col,siname,sp,si,fill,maxpack,ifill,jfill,mini)
call measures (mat1,row,col,sp,si,n0,n1,ut,nc,br,ua,up)
if(maxpack.eq.'t')call sorttemp(mat1,row,spname,sp,si,fill,ifill,jfill,mini)
if(maxpack.eq.'t')call sorttemp1(mat1,col,siname,sp,si,fill,ifill,jfill,mini)
call temperature
iout=1
tempran(i)=temp
n0sim(i)=n0
n1sim(i)=n1
ncsim(i)=nc
utsim(i)=ut
uasim(i)=ua
upsim(i)=up
brsim(i)=br
!write(9,*)brsim(i)
!if(rand.eq.'s')mat1=mat
!write(*,'(a,i5)')'Randomization: ',i
20 continue
write(4,'(a)')' '
if(rand.ne.'s')write(4,'(a,a)')'Last packed randomized matrix: ',name 
if(rand.eq.'s')write(4,'(a,a15,a,i6)')'Last packed randomized matrix: ',name,'No. of Swaps: ',rep 
write(4,'(a)')' '
write(4,'(13x,<si>(a3,1x))')(siname(j),j=1,si)
write(4,'(a)')' '
do 21 i=1,sp
write(4,'(a12,1x,<si>(i3,1x),3x,i4)')spname(i),(int(mat1(i,j)),j=1,si),row(i)
21 continue
write(4,'(a)')' '
write(4,'(13x,<si>(i3,1x))')(col(j),j=1,si)
meanran=mean(tempran,iter)
varran=variance(tempran,iter)
n0mean=mean(n0sim,iter)
n1mean=mean(n1sim,iter)
ncmean=mean(ncsim,iter)
utmean=mean(utsim,iter)
uamean=mean(uasim,iter)
upmean=mean(upsim,iter)
brmean=mean(brsim,iter)
n0var=variance(n0sim,iter)
n1var=variance(n1sim,iter)
ncvar=variance(ncsim,iter)
utvar=variance(utsim,iter)
uavar=variance(uasim,iter)
upvar=variance(upsim,iter)
brvar=variance(brsim,iter)
tempz=0
n0z=0
n1z=0
ncz=0
utz=0
uaz=0
upz=0
brz=0
if(varran.gt.0)then
varran=sqrt(varran)
tempz=(tempor-meanran)/varran
endif
if(n0var.gt.0)then
n0var=sqrt(n0var)
n0z=(n0or-n0mean)/n0var
endif
if(n1var.gt.0)then
n1var=sqrt(n1var)
n1z=(n1or-n1mean)/n1var
endif
if(ncvar.gt.0)then
ncvar=sqrt(ncvar)
ncz=(ncor-ncmean)/ncvar
endif
if(utvar.gt.0)then
utvar=sqrt(utvar)
utz=(utor-utmean)/utvar
endif
if(uavar.gt.0)then
uavar=sqrt(uavar)
uaz=(uaor-uamean)/uavar
endif
if(upvar.gt.0)then
upvar=sqrt(upvar)
upz=(upor-upmean)/upvar
endif
if(brvar.gt.0)then
brvar=sqrt(brvar)
brz=(bror-brmean)/brvar
endif
skewran=skewness(tempran,iter)
n0skew=skewness(n0sim,iter)
n1skew=skewness(n1sim,iter)
ncskew=skewness(ncsim,iter)
utskew=skewness(utsim,iter)
uaskew=skewness(uasim,iter)
upskew=skewness(upsim,iter)
brskew=skewness(brsim,iter)
call conflim (tempran,iter,tempup,tempdown)
call conflim (n0sim,iter,n0up,n0down) 
call conflim (n1sim,iter,n1up,n1down) 
call conflim (ncsim,iter,ncup,ncdown) 
call conflim (utsim,iter,utup,utdown) 
call conflim (uasim,iter,uaup,uadown) 
call conflim (upsim,iter,upup,updown) 
call conflim (brsim,iter,brup,brdown) 
22 write(3,'(a2,1x,a4,11x,7(a9,1x))')'*','File','N0','SimN0','StdDevN0','Z-N0','SkewN0','L95%CN0','U95%CN0'
write(3,'(a2,1x,a14,1x,i9,1x,6(f9.2,1x))')'N0',name,n0or,n0mean,n0var,n0z,n0skew,n0down,n0up
write(3,'(a2,1x,a4,11x,7(a9,1x))')'*','File','N1','SimN1','StdDevN1','Z-N1','SkewN1','L95%CN1','U95%CN1'
write(3,'(a2,1x,a14,1x,i9,1x,6(f9.2,1x))')'N1',name,n1or,n1mean,n1var,n1z,n1skew,n1down,n1up
write(3,'(a2,1x,a4,11x,7(a9,1x))')'*','File','NC','SimNC','StdDevNC','Z-NC','SkewNC','L95%CNC','U95%CNC'
write(3,'(a2,1x,a14,1x,i9,1x,6(f9.2,1x))')'NC',name,ncor,ncmean,ncvar,ncz,ncskew,ncdown,ncup
write(3,'(a2,1x,a4,11x,7(a9,1x))')'*','File','UA','SimUA','StdDevUA','Z-UA','SkewUA','L95%CUA','U95%CUA'
write(3,'(a2,1x,a14,1x,f9.2,1x,6(f9.2,1x))')'UA',name,uaor,uamean,uavar,uaz,uaskew,uadown,uaup
write(3,'(a2,1x,a4,11x,7(a9,1x))')'*','File','UP','SimUP','StdDevUP','Z-UP','SkewUP','L95%CUP','U95%CUP'
write(3,'(a2,1x,a14,1x,f9.2,1x,6(f9.2,1x))')'UP',name,upor,upmean,upvar,upz,upskew,updown,upup
write(3,'(a2,1x,a4,11x,7(a9,1x))')'*','File','UT','SimUT','StdDevUT','Z-UT','SkewUT','L95%CUT','U95%CUT'
write(3,'(a2,1x,a14,1x,f9.2,1x,6(f9.2,1x))')'UT',name,utor,utmean,utvar,utz,utskew,utdown,utup
write(3,'(a2,1x,a4,11x,7(a9,1x))')'*','File','BR','SimBR','StdDevBR','Z-BR','SkewBR','L95%CBR','U95%CBR'
write(3,'(a2,1x,a14,1x,i9,1x,6(f9.2,1x))')'BR',name,bror,brmean,brvar,brz,brskew,brdown,brup
write(3,'(a)')' '
write(3,'(a2,1x,a4,11x,10(a8,1x))')'*','File','Species','Sites','Mat Fill','MatTemp','SimTemp','StdDev','Z-score','Skewness','L95%Conf','U95%Conf'
write(3,'(a2,1x,a14,1x,i8,1x,i8,1x,8(f8.2,1x))')'MT',name,sp,si,fill,tempor,meanran,varran,tempz,skewran,tempdown,tempup
write(3,'(a)')' '
if(special.eq.'yes')write(9,'(a14,1x,i9,1x,5(f9.2,1x),i9)')name,bror,brmean,brvar,tempor,meanran,varran,empty
ik=sp
ij=si
if(si.gt.sp)then
ij=sp
ik=si
endif
iii=0
iij=0
write(3,'(a12,1x,3(a8,1x),2x,a12,1x,3(a8,1x))')'Species     ','TotalOcc','Temp','UnAbsOcc','Site        ','TotalOcc','Temp','UnAbsOcc'
do 9 i=1,ik
if(i.le.sp)iii=int(tempspor(i,2))
if(i.le.si)iij=int(tempsior(i,2))
if(i.le.ij)then
write(3,'(a12,1x,i8,1x,f8.2,1x,i8,3x,a12,1x,i8,1x,f8.2,1x,i8)')spnameor(i),rowor(i),tempspor(i,1),iii,sinameor(i),color(i),tempsior(i,1),iij
elseif(i.gt.ij.and.sp.ge.si)then 
write(3,'(a12,1x,i8,1x,f8.2,1x,i8)')spnameor(i),rowor(i),tempspor(i,1),iii
elseif(i.gt.ij.and.si.ge.sp)then 
write(3,'(42x,a12,1x,i8,1x,f8.2,1x,i8)')sinameor(i),color(i),tempsior(i,1),iij
endif
9 continue
write(3,'(a)')' '
write(4,'(a)')' '
close(1)
it=it+1
deallocate(mat,mat1,row,col,def,tempsp,tempsi,tempspor,tempsior,spname,siname,rowor,color,spnameor,sinameor)
name=' '
200 continue
goto 1001
1000 write(*,*)'Format error in data file'
1001 call date_and_time(time=time)
read(time(1:2),'(i2)')time1
read(time(3:4),'(i2)')time2
read(time(5:6),'(i2)')time3
time1=time1*3600+time2*60+time3-time0
time2=int(time1/3600)
time3=int(time1/60)-time2*60
time1=time1-time3*60-time2*3600
write(*,'(a,i3,a,i3,a,i3,a)')'Runtime of program: ',&
time2,'hh',time3,'min',time1,'sec'
pause
stop
end

subroutine copy
use definitions
write(*,*)'*******************************************************'
write(*,*)'*                                                     *' 
write(*,*)'* Program Nestedness: Version 1; 24.03.2006           *' 
write(*,*)'*                                                     *' 
write(*,*)'* Copyright Dr. Werner Ulrich                         *'
write(*,*)'*                                                     *'
write(*,*)'* The author does not take responsibility for correct *'
write(*,*)'* program run or any damages caused by the program.   *'
write(*,*)'*                                                     *'
write(*,*)'*******************************************************'
write(*,*)
return 
end

subroutine reading 
use definitions
integer i,j
text=' '
tt=' '
nu=0
read(filen,'(a<length>)',err=4,end=4) text
if(text.eq.' ')goto 4
nu=1
i=1
do while (i.le.length-1)
if(text(i:i).ne.' ')then
do 1 j=i,length
if(text(j:j).eq.' ') then
if(nu.gt.300) goto 2 
tt(nu)=text(i:j-1)
i=j
nu=nu+1
if(i.gt.length-2.and.nu.lt.2)goto 2
goto 3
endif
1 continue
endif
i=i+1
if(i.gt.length-2.and.nu.lt.2)goto 2
3 enddo
if(nu.lt.2)goto 2
return
4 write(*,*) 'End of input file reached'
close(filen)
return
2 return
end

real*8 function norm(iseed)
real*8 a
a=0
do while(a.lt.0.000000001)
a=ran(iseed)
enddo
norm=sqrt(-2.0*dlog(a))*cos(2.0*3.14159*ran(iseed))
!write(*,*) norm
end function

real function skewness(a,k)
real b,c,mean,skew,a(k),variance
skew=0
if(k.gt.2)then
b=variance(a,k)
c=mean(a,k)
if(b.gt.0)then
b=sqrt(b)
do 1 i=1,k
skew=skew+(a(i)-c)*(a(i)-c)*(a(i)-c)
1 continue
skewness=k/((k-1.0)*(k-2.0))*skew/(b*b*b)
if(skewness.gt.999.0)skewness=999.0
else
skewness=0
endif
else
skewness=0
endif
end function

real function variance(a,k)
real mean,square,a(k)
mean=0
square=0
if(k.gt.1)then
do 1 i=1,k
mean=mean+a(i)
square=square+a(i)*a(i)
1 continue
variance=square/k-(mean*mean)/(k*k)
if(variance.lt.0)variance=0
else
variance=0
endif
end function

real function mean(a,k)
real m,a(k)
m=0
if(k.gt.1)then
do 1 i=1,k
m=m+a(i)
1 continue
mean=m/k
else
mean=0
endif
end function

subroutine swap (mat,sp,si,rep,iseed,kswap)
integer iseed,si,sp,rep
real mat(sp,si)
jj=0
kswap=0
do while (kswap.lt.rep)
!write(*,*)'Simulation: ',j
jj=jj+1
if(jj.gt.100000)goto 31
k1=int(sp*ran(iseed))+1
k2=int(si*ran(iseed))+1
35 k3=int(sp*ran(iseed))+1
if(k3.eq.k1)goto 35
36 k4=int(si*ran(iseed))+1
if(k4.eq.k2)goto 36
if((mat(k1,k2).ne.0.and.mat(k3,k4).ne.0).or.(mat(k3,k2).ne.0.and.mat(k1,k4).ne.0))then
if((mat(k1,k2).eq.0.and.mat(k3,k4).eq.0).or.(mat(k3,k2).eq.0.and.mat(k1,k4).eq.0))then
kswap=kswap+1
a=mat(k1,k2)
mat(k1,k2)=mat(k1,k4)
mat(k1,k4)=a
a=mat(k3,k2)
mat(k3,k2)=mat(k3,k4)
mat(k3,k4)=a
endif
endif
enddo
31 return
end

subroutine measures (mat1,row,col,sp,si,n0,n1,ut,nc,br,ua,up)
integer sp,si,n0,n1,nc,br
integer row(sp),col(si),umin(si),ua1(si),up1(si)
real mat1(sp,si),ua,up,ut,a,a1,a2
n0=0
n1=0
ua=0
up=0
ut=0
nc=0
br=0
do 10 i=1,sp
do 11 j=si,2,-1
if(mat1(i,j).gt.0)then
do 12 k=j-1,1,-1
if(col(k).gt.col(j))then
if(mat1(i,k).eq.0)n0=n0+1
endif
12 continue
goto 10
endif
11 continue
10 continue
do 20 i=1,sp
do 21 j=1,si-1
if(mat1(i,j).eq.0)then
do 22 k=j+1,si
if(col(k).lt.col(j))then
if(mat1(i,k).gt.0)n1=n1+1
endif
22 continue
goto 20
endif
21 continue
20 continue 
do 1 i=1,sp
do 2 j=1,row(i)
if(mat1(i,j).eq.0)br=br+1
2 continue
1 continue
do 31 j=1,si
do 32 i=1,col(j)
if(mat1(i,j).eq.0)ut=ut+1
32 continue
31 continue
if(ut.lt.br)br=nint(ut)
ut=0
do 40 i=1,sp
umin=0
ua1=0
up1=0
do 41 j=1,si
do 42 j1=j,1,-1
if(col(j1).gt.col(j))then
if(mat1(i,j1).eq.0)ua1(j)=ua1(j)+1
endif
42 continue
do 43 j1=j,si
if(col(j1).lt.col(j))then
if(mat1(i,j1).gt.0)up1(j)=up1(j)+1
endif
43 continue
umin(j)=ua1(j)+up1(j)
41 continue
a=1000000
k=0
do 44 j=1,si
if(umin(j).lt.a)then
a=umin(j)
k=j
endif
44 continue
k1=1
a1=ua1(k)
a2=up1(k)
if(k.eq.1.or.k.eq.si)goto 39
do 46 j1=k+1,si
if(umin(j1).eq.umin(k))then
if(col(j1).lt.col(k))then
k1=k1+1
a1=ua1(j1)+a1
a2=up1(j1)+a2
endif
endif
46 continue
39 ua=a1/real(k1)+ua
up=a2/real(k1)+up
40 continue
ut=ua+up
do 5 j=1,si-1
do 6 j1=j+1,si
do 7 i=1,sp
if(mat1(i,j).gt.0.and.mat1(i,j1).gt.0)nc=nc+1
7 continue
6 continue
5 continue
return
end

subroutine temperature
use definitions
real i,j,j1,j2,ix,iy,a,a1,a2,d,d1,d2,h,u,tempin,d3,sp1,si1
tempin=100.0/0.04145
tempin=tempin/(sp*si)
a=real(sp)/real(si)
ix=sp*fill
iy=si*fill
a1=(ix-sp)/(iy-jfill)
a2=(ix-ifill)/(si-iy)
sp1=sp-jfill*a1
si1=si+ifill/a2
j1=a/(a-a1)
j2=a+a2
temp=0
tempsp=0
tempsi=0
if(dist.eq.'yes')then
write(7,'(2(i5,1x),6(f7.2,1x))')ifill,jfill,ix,iy,a1,a2,sp1,si1
write(7,'(a)')' '
endif
j=0.5
do while(j.lt.si)
i=0.5
do while(i.lt.sp)
if(i.ge.j*a)then
!d3=j*a1+sp1
!d3=1.0/(j*j)+1.0/(d3*d3)
!if(abs(1.0/d3).lt.mini) goto 4
if(abs(i-j*a1-sp1).le.mini.or.abs(j-(i-sp1)/a1).le.mini) goto 4
if((j.lt.(i-sp1)/a1).and.(mat1(int(i)+1,int(j)+1).eq.0).or.&
(j.gt.(i-sp1)/a1).and.(mat1(int(i)+1,int(j)+1).gt.0))then
h=i-j*a
u=j1-a*j/(sp1-h)
u=u*u
if(dist.eq.'yes')then
mat2(int(i)+1,int(j)+1)=u
endif
temp=temp+u
tempsp(int(i)+1,1)=tempsp(int(i)+1,1)+u
tempsi(int(j)+1,1)=tempsi(int(j)+1,1)+u
tempsp(int(i)+1,2)=tempsp(int(i)+1,2)+1
tempsi(int(j)+1,2)=tempsi(int(j)+1,2)+1
endif
elseif(i.lt.j*a)then
!d3=(si1-j)*a2
!d3=1.0/(j*j)+1.0/(d3*d3)
!if(abs(1.0/d3).lt.mini) goto 4
if(abs(i-(si1-j)*a2).le.mini.or.abs(j-si1+i/a2).le.mini) goto 4
if((j.lt.si1-i/a2).and.(mat1(int(i)+1,int(j)+1).eq.0).or.&
(j.gt.si1-i/a2).and.(mat1(int(i)+1,int(j)+1).gt.0))then
h=i-j*a
u=((si1*a2-h)/j2-j)/(si1+h/a)
u=u*u
if(dist.eq.'yes')then
mat2(int(i)+1,int(j)+1)=u
endif
temp=temp+u
tempsp(int(i)+1,1)=tempsp(int(i)+1,1)+u
tempsi(int(j)+1,1)=tempsp(int(j)+1,1)+u
tempsp(int(i)+1,2)=tempsp(int(i)+1,2)+1
tempsi(int(j)+1,2)=tempsp(int(j)+1,2)+1
endif
endif
4 i=i+1.0
enddo
j=j+1.0
enddo
do 1 k=1,sp
tempsp(k,1)=min(tempsp(k,1)*tempin*sp,100.0)
1 continue
do 2 k=1,si
tempsi(k,1)=min(tempsi(k,1)*tempin*si,100.0)
2 continue
temp=temp*tempin
if(temp.lt.0)temp=0
if(temp.gt.100.0)temp=100.0
return
end

subroutine tempmax(mat1,sp,si,fill,temppack,ifill,jfill,mini)
integer sp,si,ifill,jfill
real mat1(sp,si)
real i,j,j1,j2,ix,iy,a,a1,a2,d,d1,d2,h,u,tempin,fill,temppack,mini,d3,sp1,si1
tempin=100.0/0.04145
tempin=tempin/(sp*si)
a=real(sp)/real(si)
ix=sp*fill
iy=si*fill
a1=(ix-sp)/iy
a2=ix/(si-iy)
sp1=sp-jfill*a1
si1=si+ifill/a2
j1=a/(a-a1)
j2=a+a2
temppack=0
i=0.5
do while(i.lt.sp)
j=0.5
do while(j.lt.si)
if(i.ge.j*a)then
!d3=j*a1+sp1
!d3=1.0/(j*j)+1.0/(d3*d3)
!if(abs(1.0/d3).lt.mini) goto 4
if(abs(i-j*a1-sp1).le.mini.or.abs(j-(i-sp1)/a1).le.mini) goto 4
if((j.lt.(i-sp1)/a1).and.(mat1(int(i)+1,int(j)+1).eq.0).or.&
(j.gt.(i-sp1)/a1).and.(mat1(int(i)+1,int(j)+1).gt.0))then
h=i-j*a
u=j1-a*j/(sp1-h)
u=u*u
temppack=temppack+u
endif
elseif(i.lt.j*a)then
!d3=(si1-j)*a2
!d3=1.0/(j*j)+1.0/(d3*d3)
!if(abs(1.0/d3).lt.mini) goto 4
if(abs(i-(si1-j)*a2).le.mini.or.abs(j-si1+i/a2).le.mini) goto 4
if((j.lt.si1-i/a2).and.(mat1(int(i)+1,int(j)+1).eq.0).or.&
(j.gt.si1-i/a2).and.(mat1(int(i)+1,int(j)+1).gt.0))then
h=i-j*a
u=((si1*a2-h)/j2-j)/(si1+h/a)
u=u*u
temppack=temppack+u
!write(*,*)temppack,tempin
endif
endif
4 j=j+1.0
enddo
i=i+1.0
enddo
temppack=temppack*tempin
if(temppack.lt.0)temppack=0
if(temppack.gt.100.0)temppack=100.0
return
end


subroutine sort(field,row,spname,sp,si,fill,maxpack,ifill,jfill,mini)
integer sp,si,ifill
integer row(sp),a
real field(sp,si),an(si),fill,mini
character*50,spname(sp),b
character*10 maxpack,err
!err=maxpack
3 row=0
do 10 i1=1,sp
do 11 j1=1,si
if(field(i1,j1).gt.0)row(i1)=row(i1)+1
11 continue
10 continue
do 2 j1=1,sp-1
do 1 i1=j1+1,sp
if(row(i1).gt.row(j1))then
do 5 k1=1,si
an(k1)=field(j1,k1)
field(j1,k1)=field(i1,k1)
field(i1,k1)=an(k1)
5 continue
a=row(j1)
b=spname(j1)
row(j1)=row(i1)
spname(j1)=spname(i1)
row(i1)=a
spname(i1)=b
endif
1 continue
2 continue
i=0
do while(row(i+1).eq.si)
i=i+1
if(i.gt.sp) goto 6
enddo
6 if(i.eq.0)ifill=0
if(i.gt.0)ifill=i-1
!if(maxpack.eq.'t')call sorttemp(field,row,spname,sp,si,fill,ifill,jfill,mini)
!if(row(1).lt.row(sp))then
!err='err'
!goto 3
!endif
return
end

subroutine sort1(field,col,siname,sp,si,fill,maxpack,ifill,jfill,mini)
integer sp,si,jfill
real field(sp,si),an(sp),fill,mini
integer col(si),a
character*50,siname(si),b
character*10 maxpack,err
!err=maxpack
3 col=0
do 10 i1=1,si
do 11 j1=1,sp
if(field(j1,i1).gt.0)col(i1)=col(i1)+1
11 continue
10 continue
do 2 j1=1,si-1
do 1 i1=j1+1,si
if(col(i1).gt.col(j1))then
do 5 k1=1,sp
an(k1)=field(k1,j1)
field(k1,j1)=field(k1,i1)
field(k1,i1)=an(k1)
5 continue
a=col(j1)
b=siname(j1)
col(j1)=col(i1)
siname(j1)=siname(i1)
col(i1)=a
siname(i1)=b
endif
1 continue
2 continue
i=0
do while(col(i+1).eq.sp)
i=i+1
if(i.gt.si) goto 6
enddo
6 if(i.eq.0)jfill=0
if(i.gt.0)jfill=i-1
!if(maxpack.eq.'t')call sorttemp1(field,col,siname,sp,si,fill,ifill,jfill,mini)
!if(col(1).lt.col(si))then
!err='err'
!goto 3
!endif
return
end

subroutine sorttemp(field,row,spname,sp,si,fill,ifill,jfill,mini)
integer sp,si,ifill,jfill
integer row(sp),a
real field(sp,si),an(si),temppack,fill,v1,v2,mini
character*50,spname(sp),b
temppack=0
do 2 j1=1,sp-1
do 1 i1=j1+1,sp
call tempmax (field,sp,si,fill,temppack,ifill,jfill,mini)
v1=temppack
do 3 k1=1,si
an(k1)=field(j1,k1)
field(j1,k1)=field(i1,k1)
field(i1,k1)=an(k1)
3 continue
a=row(j1)
b=spname(j1)
row(j1)=row(i1)
spname(j1)=spname(i1)
row(i1)=a
spname(i1)=b
call tempmax (field,sp,si,fill,temppack,ifill,jfill,mini)
v2=temppack
if(v1.le.v2)then
do 5 k1=1,si
an(k1)=field(j1,k1)
field(j1,k1)=field(i1,k1)
field(i1,k1)=an(k1)
5 continue
a=row(j1)
b=spname(j1)
row(j1)=row(i1)
spname(j1)=spname(i1)
row(i1)=a
spname(i1)=b
endif
1 continue
2 continue
return
end

subroutine sorttemp1(field,col,siname,sp,si,fill,ifill,jfill,mini)
integer sp,si,ifill,jfill
real field(sp,si),an(sp),temppack,fill,v1,v2,mini
integer col(si),a
character*50,siname(si),b
temppack=0
do 2 j1=1,si-1
do 1 i1=j1+1,si
call tempmax (field,sp,si,fill,temppack,ifill,jfill,mini)
v1=temppack
do 3 k1=1,sp
an(k1)=field(k1,j1)
field(k1,j1)=field(k1,i1)
field(k1,i1)=an(k1)
3 continue
a=col(j1)
b=siname(j1)
col(j1)=col(i1)
siname(j1)=siname(i1)
col(i1)=a
siname(i1)=b
call tempmax (field,sp,si,fill,temppack,ifill,jfill,mini)
v2=temppack
if(v1.le.v2)then
do 5 k1=1,sp
an(k1)=field(k1,j1)
field(k1,j1)=field(k1,i1)
field(k1,i1)=an(k1)
5 continue
a=col(j1)
b=siname(j1)
col(j1)=col(i1)
siname(j1)=siname(i1)
col(i1)=a
siname(i1)=b
endif
1 continue
2 continue
return
end

subroutine sort2(field,i)
integer i
real field(i),an
do 2 j1=1,i-1
do 1 i1=j1+1,i
an=field(j1)
if(field(i1).gt.an)then
field(j1)=field(i1)
field(i1)=an
endif
1 continue
2 continue
return
end

subroutine conflim (field,i,up,down)
integer i,i1,i2
real field(i),up,down
i1=nint(0.025*i)
if(i1.lt.1)i1=1
i2=nint(0.975*i)
if(i1.gt.i)i1=i
call sort2(field,i)
up=field(i1)
down=field(i2)
return
end

subroutine sad (field1,spec,iseed,a)
integer spec,iseed, num
real field(spec),a,b, field1(spec)
real*8 norm
b=0
num=10
field1=0
do 5 k=1,num
field=0
b=0
do 1 i=1,spec
2 field(i)=a*norm(iseed)
if(field(i).lt.16.and.field(i).gt.-16)then
field(i)=exp(field(i))
b=b+field(i)
else
goto 2
endif
1 continue
if(b.gt.0)then
call sort3(field,spec)
do 3 i=1,spec
field(i)=field(i)/b
field1(i)=field(i)+field1(i)
3 continue
else
field=0
endif
5 continue
do 6 i=1, spec
field1(i)=field1(i)/real(num)
6 continue
return
end

subroutine sort3 (field,i)
real field(i),an
do 2 j1=1,i-1
do 1 i1=j1+1,i
an=field(j1)
if(field(i1).gt.an)then
field(j1)=field(i1)
field(i1)=an
5 continue
endif
1 continue
2 continue
return
end


subroutine prob (rad,sp,jj,iseed)
integer jj,sp
real an,rad(sp,5),probf(sp)
probf=0
probf(1)=rad(1,2)
do 1 i=2,sp
probf(i)=rad(i,2)+probf(i-1)
1 continue
an=ran(iseed)*probf(sp)
do 2 jj=1,sp
if(an.lt.probf(jj))return
2 continue
jj=0
return
end

subroutine sample (out,rowor,def,sp,si,iseed,sadslope,rand,iout)
real*8 ran1
integer i,j,jj,jjj,sp,si,iseed
real*8 norm
real item,item1,item2,total2,min,max,def1,sadslope
real rad(sp,5),out(sp,si),in(sp)
integer ii,samps,iter,num1,filec,def(si),rowor(sp)
character*10 time,rand
if(rand.eq.'l')call sad(in,sp,iseed,sadslope)
if(rand.eq.'o')in=rowor
if(iout.eq.0.and.(rand.eq.'l'.or.rand.eq.'o'))then
write(7,'(a)')'Sample distribution'
do 1 i=1,sp
write(7,'(f12.10)')in(i)
1 continue
endif
rad=0
out=0
samps=1
min=10**9
max=-1.0
k1=0
do 201 i=1,sp
rad(i,5)=i
rad(i,1)=in(i)
rad(i,2)=in(i)
if(rad(i,2).gt.max)max=rad(i,2)
if(rad(i,2).lt.min)min=rad(i,2)
201 continue
do 203 i=1,sp
if(max.le.1.and.min.lt.1)then
rad(i,1)=rad(i,1)/min
endif
203 continue
do 30 jjj=1,si
do 20 i=1,sp
rad(i,2)=rad(i,1)
rad(i,3)=0
rad(i,4)=1
20 continue
item2=0.5
do while (item2.lt.def(jjj))
call prob(rad,sp,jj,iseed)
k1=k1+1
if(k1.gt.1000000)goto 40
if(rad(jj,3).lt.rad(jj,2).and.jj.gt.0.and.jj.le.sp)then
rad(jj,3)=rad(jj,3)+1
rad(jj,4)=0
item2=0
do 5 k=1,sp
5 if(rad(k,4).eq.0)item2=item2+1
endif
enddo
40 do 202 i=1,sp
if(rad(i,3).gt.0)then
out(i,jjj)=1.0
!out(i,jjj)=rad(i,3)
endif
202 continue
30 continue
200 return
end

subroutine equi(mat1,sp,si,iseed,empty)
integer sp,si,iseed,empty
real mat1(sp,si)
mat1=0.0
do 1 k=1,empty
2 i=int(ran(iseed)*sp)+1
j=int(ran(iseed)*si)+1
if(mat1(i,j).eq.1)goto 2
mat1(i,j)=1
1 continue
return
end

subroutine fixrow(mat1,sp,si,rep,iseed)
integer sp,si,iseed,i,j1,j2,rep
real mat1(sp,si),a
do 1 k=1,rep
i=int(ran(iseed)*sp)+1
j1=int(ran(iseed)*si)+1
j2=int(ran(iseed)*si)+1
a=mat1(i,j1)
mat1(i,j1)=mat1(i,j2)
mat1(i,j2)=a
1 continue
!do 2 k=1,sp
!2 write(9,'(<si>(f4.2,1x))')(mat1(k,k1),k1=1,si)
!write(9,*)rep
return
end

subroutine fixcol(mat1,sp,si,rep,iseed)
integer sp,si,iseed,i1,i2,j,rep
real mat1(sp,si),a
do 1 k=1,rep
j=int(ran(iseed)*si)+1
i1=int(ran(iseed)*sp)+1
i2=int(ran(iseed)*sp)+1
a=mat1(i1,j)
mat1(i1,j)=mat1(i2,j)
mat1(i2,j)=a
1 continue
return
end		